const t1111 = `

1.主程序
/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "define.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
ADC_HandleTypeDef hadc;
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
//static void MX_DAC_Init(void);
static void MX_USART1_UART_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_USART3_UART_Init(void);
static void MX_IWDG_Init(void);
static void MX_TIM2_Init(void);
static void MX_TIM6_Init(void);
static void MX_ADC_Init(void);
void StartDefaultTask(void const * argument);

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
//  MX_DAC_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();
  MX_USART3_UART_Init();
//  MX_IWDG_Init();
  MX_TIM2_Init();
  MX_TIM6_Init();
  /* USER CODE BEGIN 2 */
	MX_ADC_Init();
	LCD_GPIO_Init();
	LCD_Config();
	U1RXMODE;//开启RS485接收模式
//	HAL_UART_Receive_DMA(&huart1,U1RXBUF,128);//启动接收
//	__HAL_UART_ENABLE_IT(&huart1, UART_IT_IDLE);
	
  /* USER CODE END 2 */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* definition and creation of defaultTask */

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
	
	osSemaphoreDef(U1Seamp);
  U1SeampHandle = osSemaphoreCreate(osSemaphore(U1Seamp), 1);
  osSemaphoreDef(U2Seamp);
  U2SeampHandle = osSemaphoreCreate(osSemaphore(U2Seamp), 1);
  osSemaphoreDef(U3Seamp);
  U3SeampHandle = osSemaphoreCreate(osSemaphore(U3Seamp), 1);
	
	while(xSemaphoreTake(U1SeampHandle,0)==pdTRUE);		//拿掉默认信号量
	while(xSemaphoreTake(U2SeampHandle,0)==pdTRUE);		//拿掉默认信号量
	while(xSemaphoreTake(U3SeampHandle,0)==pdTRUE);		//拿掉默认信号量
	
	osThreadDef(MAINTASK, MainTask, osPriorityLow, 0, 128);
  MAINTASKHandle = osThreadCreate(osThread(MAINTASK), NULL);
  /* USER CODE END RTOS_THREADS */

  /* Start scheduler */
  osKernelStart();
  
  /* We should never get here as control is now taken by the scheduler */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI
                              |RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL6;
  RCC_OscInitStruct.PLL.PLLDIV = RCC_PLL_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief DAC Initialization Function
  * @param None
  * @retval None
  */
//static void MX_DAC_Init(void)
//{

//  /* USER CODE BEGIN DAC_Init 0 */

//  /* USER CODE END DAC_Init 0 */

//  DAC_ChannelConfTypeDef sConfig = {0};

//  /* USER CODE BEGIN DAC_Init 1 */

//  /* USER CODE END DAC_Init 1 */
//  /** DAC Initialization 
//  */
//  hdac.Instance = DAC;
//  if (HAL_DAC_Init(&hdac) != HAL_OK)
//  {
//    Error_Handler();
//  }
//  /** DAC channel OUT1 config 
//  */
//  sConfig.DAC_Trigger = DAC_TRIGGER_SOFTWARE;
//  sConfig.DAC_OutputBuffer = DAC_OUTPUTBUFFER_ENABLE;
//  if (HAL_DAC_ConfigChannel(&hdac, &sConfig, DAC_CHANNEL_1) != HAL_OK)
//  {
//    Error_Handler();
//  }
//  /* USER CODE BEGIN DAC_Init 2 */
//	
////	HAL_DAC_Start(&hdac,DAC_CHANNEL_1);//开始输出DAC1
//	
//  /* USER CODE END DAC_Init 2 */

//}

/**
  * @brief IWDG Initialization Function
  * @param None
  * @retval None
  */
static void MX_IWDG_Init(void)
{

  /* USER CODE BEGIN IWDG_Init 0 */

  /* USER CODE END IWDG_Init 0 */

  /* USER CODE BEGIN IWDG_Init 1 */

  /* USER CODE END IWDG_Init 1 */
  hiwdg.Instance = IWDG;
  hiwdg.Init.Prescaler = IWDG_PRESCALER_8;
  hiwdg.Init.Reload = 4095;
  if (HAL_IWDG_Init(&hiwdg) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN IWDG_Init 2 */

  /* USER CODE END IWDG_Init 2 */

}

/**
  * @brief TIM2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM2_Init(void)
{

  /* USER CODE BEGIN TIM2_Init 0 */

  /* USER CODE END TIM2_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};
  TIM_IC_InitTypeDef sConfigIC = {0};

  /* USER CODE BEGIN TIM2_Init 1 */

  /* USER CODE END TIM2_Init 1 */
  htim2.Instance = TIM2;
  htim2.Init.Prescaler = 0;
  htim2.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim2.Init.Period = 65535;
  htim2.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  if (HAL_TIM_Base_Init(&htim2) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim2, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_IC_Init(&htim2) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim2, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigIC.ICPolarity = TIM_INPUTCHANNELPOLARITY_RISING;
  sConfigIC.ICSelection = TIM_ICSELECTION_DIRECTTI;
  sConfigIC.ICPrescaler = TIM_ICPSC_DIV1;
  sConfigIC.ICFilter = 0;
  if (HAL_TIM_IC_ConfigChannel(&htim2, &sConfigIC, TIM_CHANNEL_2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM2_Init 2 */
	
	__HAL_TIM_CLEAR_IT(&htim2, TIM_IT_UPDATE);
	HAL_TIM_Base_Start_IT(&htim2);            //开启进行TIM2计数
	HAL_TIM_IC_Start_IT(&htim2,TIM_CHANNEL_2);//开始捕获TIM2_CH2通道数据
	
  /* USER CODE END TIM2_Init 2 */

}

/**
  * @brief TIM6 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM6_Init(void)
{

  /* USER CODE BEGIN TIM6_Init 0 */

  /* USER CODE END TIM6_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM6_Init 1 */

  /* USER CODE END TIM6_Init 1 */
  htim6.Instance = TIM6;
  htim6.Init.Prescaler = 24;
  htim6.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim6.Init.Period = 2000;
  if (HAL_TIM_Base_Init(&htim6) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim6, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM6_Init 2 */

  /* USER CODE END TIM6_Init 2 */

}
/**
  * @brief TIM7 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM7_Init(void)
{

  /* USER CODE BEGIN TIM7_Init 0 */

  /* USER CODE END TIM7_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM7_Init 1 */

  /* USER CODE END TIM7_Init 1 */
  htim7.Instance = TIM7;
  htim7.Init.Prescaler = 24;
  htim7.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim7.Init.Period = 0;
  if (HAL_TIM_Base_Init(&htim7) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim7, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM7_Init 2 */

  /* USER CODE END TIM7_Init 2 */

}
/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 115200;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */
  HAL_UART_Receive_IT(&huart1,U1BUF,1);
  /* USER CODE END USART1_Init 2 */

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 9600;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief USART3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART3_UART_Init(void)
{

  /* USER CODE BEGIN USART3_Init 0 */
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  /* USER CODE END USART3_Init 0 */

  /* USER CODE BEGIN USART3_Init 1 */

  /* USER CODE END USART3_Init 1 */
  huart3.Instance = USART3;
  huart3.Init.BaudRate = 9600;
  huart3.Init.WordLength = UART_WORDLENGTH_8B;
  huart3.Init.StopBits = UART_STOPBITS_1;
  huart3.Init.Parity = UART_PARITY_NONE;
  huart3.Init.Mode = UART_MODE_TX_RX;
  huart3.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart3.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART3_Init 2 */
//	GPIO_InitStruct.Pin = GPIO_PIN_10;
//	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
//	GPIO_InitStruct.Pull = GPIO_NOPULL;
//	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
//	HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
  /* USER CODE END USART3_Init 2 */

}

/** 
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void) 
{
  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Channel2_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel2_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel2_IRQn);
  /* DMA1_Channel3_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel3_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel3_IRQn);
  /* DMA1_Channel4_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel4_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel4_IRQn);
  /* DMA1_Channel5_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel5_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel5_IRQn);
  /* DMA1_Channel6_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel6_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel6_IRQn);
  /* DMA1_Channel7_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel7_IRQn, 5, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel7_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_12 
                          |GPIO_PIN_8, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_11, GPIO_PIN_RESET);

  /*Configure GPIO pins : PC13 PC14 PC15 */
  GPIO_InitStruct.Pin = GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : PB0 PB1 PB2 PB12 
                           PB8 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_12 
                          |GPIO_PIN_8;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : PA11 */
  GPIO_InitStruct.Pin = GPIO_PIN_11;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */
void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart)
{
	if(huart->Instance==huart1.Instance)//USART1发送完成回调函数
	{
		U1RXMODE;//开启RS485接收模式
		HAL_UART_Receive_DMA(&huart1,U1RXBUF,128);//启动接收
		__HAL_UART_ENABLE_IT(&huart1, UART_IT_IDLE);
//		HAL_UART_Receive_IT(&huart1,U1BUF,1);
	}
}
//串口接收回调函数
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	static uint8_t  U3RXtemp[1]={0};
	if(huart->Instance==huart3.Instance)//USART3接收完成回调函数
	{
		 __HAL_TIM_SET_COUNTER(&htim6,0);
		if(0 == U3RXPTR)
    {
    __HAL_TIM_CLEAR_FLAG(&htim6,TIM_FLAG_UPDATE);
      HAL_TIM_Base_Start_IT(&htim6);
    }
    U3RXBUF[U3RXPTR] = U3BUF[0];
    U3RXPTR++;
    HAL_UART_Receive_IT(&huart3,(uint8_t *)U3BUF,1);
	}
	if(huart->Instance==huart1.Instance)//USART1接收完成回调函数
	{
		usart1_tim=0;//清空计数
//		if(0 == U1RXPTR)
//    {
			U1_RX_START_FLAG=1;
//    }
    U1RXBUF[U1RXPTR] = U1BUF[0];
    U1RXPTR++;
    HAL_UART_Receive_IT(&huart1,(uint8_t *)U1BUF,1);
	}
}

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
	portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
	extern osSemaphoreId U3SeampHandle;
	static unsigned short revdata=0;
	
	if(htim->Instance==htim2.Instance)//遥控接收处理
	{
		HAL_TIM_Base_Stop_IT(&htim2);
		TIM2BITCNT=0;																//复位位接收计数器
		if(TIM2BYTECNT>0)														//第二次收到数据
		{
			if(revdata==TIM2REVBIT)										//前后两次值相同
			{
				if(revdata==0x2AF)KEYVAL=KEY_ST;			  //输出按键值
				else if(revdata==0x2B7)KEYVAL=KEY_OK;
				else if(revdata==0x2BB)KEYVAL=KEY_CL;
				else if(revdata==0x377)KEYVAL=KEY_UP;
				else if(revdata==0x36F)KEYVAL=KEY_DN;
				TIM2BYTECNT=0;													//复位数据接收计数器,等待下一个键按下
			}
			else																			//前后两次值不相同
			{
				revdata=TIM2REVBIT;											//再次保存收到的数据,等待下一数据(丢弃先前收到的数据)
			}
		}
		else																				//第一次收到数据
		{
			revdata=TIM2REVBIT;												//保存收到的数据
			TIM2BYTECNT++;														//等待下一个数据
		}
	}
	if(htim->Instance==htim6.Instance)//USART3接收超时
	{
		HAL_TIM_Base_Stop_IT(&htim6);
		if(U3RXPTR>0)
		{
			U3RXLEN=U3RXPTR;
			xSemaphoreGiveFromISR( U3SeampHandle, &xHigherPriorityTaskWoken );//发送信号量
		}
		portYIELD_FROM_ISR( xHigherPriorityTaskWoken );	//任务切换
	}
}

void HAL_TIM_IC_CaptureCallback(TIM_HandleTypeDef *htim)
{
	static uint16_t ICValue;
	if((htim->Channel == HAL_TIM_ACTIVE_CHANNEL_2)&& (htim->Instance == TIM2) )//TIM2_CH2输入捕捉
	{
		 __HAL_TIM_SET_COUNTER(&htim2,0);
		ICValue=HAL_TIM_ReadCapturedValue(&htim2, TIM_CHANNEL_2);
		if(TIM2BITCNT++!=0)															//不是收到第一个下降沿
		{
			TIM2REVBIT<<=1;
			if(ICValue>30600)TIM2REVBIT++;								  //获得数据位
		}
		else																						//收到第一个下降沿,开更新中断
		{
			TIM2REVBIT=0;																	//复位位数据
			__HAL_TIM_CLEAR_IT(&htim2, TIM_IT_UPDATE);
			HAL_TIM_Base_Start_IT(&htim2);
		}
	}
}


//获得ADC值
//ch: 通道值 0~16，取值范围为：ADC_CHANNEL_0~ADC_CHANNEL_16
//返回值:转换结果
u16 Get_Adc(u32 ch)   
{
    ADC_ChannelConfTypeDef ADC1_ChanConf;
  
    ADC1_ChanConf.Channel=ch;                                   //通道
    ADC1_ChanConf.Rank=1;                                       //第1个序列，序列1            
    HAL_ADC_ConfigChannel(&hadc,&ADC1_ChanConf);        //通道配置
    HAL_ADC_Start(&hadc);                               //开启ADC
//    HAL_ADC_PollForConversion(&hadc,10);                //轮询转换
		return (u16)HAL_ADC_GetValue(&hadc);	        	//返回最近一次ADC1规则组的转换结果
}

//获取指定通道的转换值，取times次,然后平均 
//times:获取次数
//返回值:通道ch的times次转换结果平均值
u16 Get_Adc_Average(u32 ch,u8 times)
{
	u32 temp_val=0;
	u8 t;
	for(t=0;t<times;t++)
	{
		temp_val+=Get_Adc(ch);
		HAL_Delay(5);
	}
	return temp_val/times;
}

/**
  * @brief ADC Initialization Function
  * @param None
  * @retval None
  */
static void MX_ADC_Init(void)
{

  /* USER CODE BEGIN ADC_Init 0 */

  /* USER CODE END ADC_Init 0 */

  ADC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN ADC_Init 1 */

  /* USER CODE END ADC_Init 1 */
  /** Configure the global features of the ADC (Clock, Resolution, Data Alignment and number of conversion)
  */
  hadc.Instance = ADC1;
  hadc.Init.ClockPrescaler = ADC_CLOCK_ASYNC_DIV1;
  hadc.Init.Resolution = ADC_RESOLUTION_12B;
  hadc.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc.Init.ScanConvMode = ADC_SCAN_DISABLE;
  hadc.Init.EOCSelection = ADC_EOC_SEQ_CONV;
  hadc.Init.LowPowerAutoWait = ADC_AUTOWAIT_DISABLE;
  hadc.Init.LowPowerAutoPowerOff = ADC_AUTOPOWEROFF_DISABLE;
  hadc.Init.ChannelsBank = ADC_CHANNELS_BANK_A;
  hadc.Init.ContinuousConvMode = DISABLE;
  hadc.Init.NbrOfConversion = 1;
  hadc.Init.DiscontinuousConvMode = DISABLE;
  hadc.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc.Init.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
  hadc.Init.DMAContinuousRequests = DISABLE;
  if (HAL_ADC_Init(&hadc) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure for the selected ADC regular channel its corresponding rank in the sequencer and its sample time.
  */
  sConfig.Channel = ADC_CHANNEL_0;
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_4CYCLES;
  if (HAL_ADC_ConfigChannel(&hadc, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ADC_Init 2 */

  /* USER CODE END ADC_Init 2 */

}
/* USER CODE END 4 */

/* USER CODE BEGIN Header_StartDefaultTask */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used 
  * @retval None
  */
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void const * argument)
{

  /* USER CODE BEGIN 5 */
//  /* Infinite loop */
//  for(;;)
//  {
//    osDelay(1);
//  }
  /* USER CODE END 5 */ 
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */




`;

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

export const t2222 = `
2.任务函数
#include "define.h"

const unsigned char *MENU[]={"S-01","S-02","S-03","S-04","S-05","S-06","S-07","S-08"
											,"S-09","S-10","S-11","S-12","S-13","S-14","S-15","S-16"};
static u8 diplay=0xEE;
//========================================TASK========================================================//
extern u16 Get_Adc_Average(u32 ch,u8 times);
void MainTask(void const * argument)//主任务函数(状态控制任务显示任务)
{
	static u8 cnt=0,cnt1=0,a=0;
	portTickType xLastWakeTime;
	
	osThreadDef(DISPTASK, DispTask, osPriorityLow, 0, 128);
  DISPTASKHandle = osThreadCreate(osThread(DISPTASK), NULL);
	
	osThreadDef(U1TASK, U1Task, osPriorityLow, 0, 128);
  U1TASKHandle = osThreadCreate(osThread(U1TASK), NULL);
	
	osThreadDef(U2TASK, U2Task, osPriorityLow, 0, 128);
  U2TASKHandle = osThreadCreate(osThread(U2TASK), NULL);
	
	osThreadDef(U3TASK, U3Task, osPriorityLow, 0, 128);
  U3TASKHandle = osThreadCreate(osThread(U3TASK), NULL);
	
	xLastWakeTime = xTaskGetTickCount();
	
	PARA_CONFIG_LOAD();//读取配置数据
	HAL_UART_Receive_IT(&huart1,U1BUF,1);

	for(;;)
  {
		if(DISPLAY==0)HAL_IWDG_Refresh(&hiwdg);//喂狗
		vTaskDelayUntil( &xLastWakeTime, 200 );//等待100ms
		{
			HAL_IWDG_Refresh(&hiwdg);//喂狗
			if(cnt++>=3 && DISPLAY!=19)
			{
				cnt=0;
				a=~a;
				LED1(a);
			}
			if(LCD_CONECT==GPIO_PIN_RESET)//显示板连接监测
			{
				if(cnt1++>=10)
				{
					cnt1=0;
					SYSBIT|=(1<<3);//显示板拔出标志置位
				}
			}
			else
			{
				if(SYSBIT&(1<<3))
				{
					if(cnt1++>=10)
					{
						cnt1=0;
						LCD_Config();
						diplay=0xEE;
						HAL_Delay(100);
						SYSBIT&=~(1<<3);//显示板拔出标志恢复
					}
				}
			}
			if(SYSBIT&(1<<5))//配置数据保存标志置位
			{
				SYSBIT&=~(1<<5);
				FLASH_CONFIG_WRITE();
			}
			DETECTOR_STATE_CON();//探测器状态监测   高低报和故障判断
			if(DISPLAY>=16 && DISPLAY<=17)
			{
				DAC_OUTPUT_CON(2);//DAC1调整输出
			}
			else
			{
				DAC_OUTPUT_CON(1);//DAC1正常输出
			}
			if((SYSBIT&(1<<4))==0)
			{
				if((ERRSTA&16)==0)
				{
					PARA_CONFIG_LOAD();
				}
			}
		}
		osDelay(10);
	}
}


void DispTask(void const * argument)//显示任务函数
{
	u8 i;
	s32 val=0;
	static u8 BitSelect=0,ReadCon=1,bit[4]={0,0,0,0},Bithold=0,dotadd=0;
	static u16 BitValue=0;
	char data[10]={0};
	LCD_Full(ALL);
	HAL_Delay(2000);
	LCD_Full(CLEAR);
	LCD_DISINT(MVER,2,ON,B8,OFF);
	LCDATA[13]=0x07;
	LCDATA[12]=0x0A;
	LCD_Full(DATA);
	HAL_Delay(1000);
	for(i=0;i<120;i++)
	{
		LCD_DISINT((120-i),0,ON,B8,OFF);
		LCD_DISSTR((const u8 *)"PrEH",S8,OFF);
		HAL_Delay(500);
		LCD_Full(DATA);
		LCD_DISSTR((const u8 *)"....",S8,OFF);
		HAL_Delay(500);
		LCD_Full(DATA);
		if(KEYVAL==KEY_CL && i>30)break;
		if(ERRSTA&16)break;
		if(SYSBIT&(1<<3))break;
	}
	KEYVAL=0;
	DISPLAY=1;
	SYSBIT|=(1<<2);//系统进入工作模式
	for(;;)
  {
		if(diplay!= DISPLAY){  //页面切换初始化 OK
			LCD_Full(CLEAR);
			LCD_DISICON(LINE,ON);
			LCD_DISICON(RUNOK,ON);
			if(Bithold==0)
				BitSelect=0;
			else 
			{
				BitSelect=Bithold;
				Bithold=0;
			}
			if(DISPLAY==11)BitSelect=1;
			ReadCon=1;
			BitValue=0;
			bit[0]=bit[1]=bit[2]=bit[3]=0;
			diplay=DISPLAY;
		}
		if(DISPLAY== 1)     {  //正常监控界面 OK
			//轮询显示画面
			if(CH_FLAG==0)
			{
				if(SCONFIG.ITEM.DOT==0)
					LCD_DISINT((u16)SCONFIG.ITEM.GASVAL,SCONFIG.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG.ITEM.DOT==1)
					LCD_DISINT((u16)(SCONFIG.ITEM.GASVAL*10),SCONFIG.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG.ITEM.DOT==2)
					LCD_DISINT((u16)(SCONFIG.ITEM.GASVAL*100),SCONFIG.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG.ITEM.DOT==3)
					LCD_DISINT((u16)(SCONFIG.ITEM.GASVAL*1000),SCONFIG.ITEM.DOT,ON,B8,OFF);
			}
			else if(CH_FLAG==1)
			{
				if(SCONFIG_2.ITEM.DOT==0)
					LCD_DISINT((u16)SCONFIG_2.ITEM.GASVAL,SCONFIG_2.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_2.ITEM.DOT==1)
					LCD_DISINT((u16)(SCONFIG_2.ITEM.GASVAL*10),SCONFIG_2.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_2.ITEM.DOT==2)
					LCD_DISINT((u16)(SCONFIG_2.ITEM.GASVAL*100),SCONFIG_2.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_2.ITEM.DOT==3)
					LCD_DISINT((u16)(SCONFIG_2.ITEM.GASVAL*1000),SCONFIG_2.ITEM.DOT,ON,B8,OFF);
			}
			else if(CH_FLAG==2)
			{
				if(SCONFIG_3.ITEM.DOT==0)
					LCD_DISINT((u16)SCONFIG_3.ITEM.GASVAL,SCONFIG_3.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_3.ITEM.DOT==1)
					LCD_DISINT((u16)(SCONFIG_3.ITEM.GASVAL*10),SCONFIG_3.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_3.ITEM.DOT==2)
					LCD_DISINT((u16)(SCONFIG_3.ITEM.GASVAL*100),SCONFIG_3.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_3.ITEM.DOT==3)
					LCD_DISINT((u16)(SCONFIG_3.ITEM.GASVAL*1000),SCONFIG_3.ITEM.DOT,ON,B8,OFF);
			}
			else if(CH_FLAG==3)
			{
				if(SCONFIG_4.ITEM.DOT==0)
					LCD_DISINT((u16)SCONFIG_4.ITEM.GASVAL,SCONFIG_4.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_4.ITEM.DOT==1)
					LCD_DISINT((u16)(SCONFIG_4.ITEM.GASVAL*10),SCONFIG_4.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_4.ITEM.DOT==2)
					LCD_DISINT((u16)(SCONFIG_4.ITEM.GASVAL*100),SCONFIG_4.ITEM.DOT,ON,B8,OFF);
				else if(SCONFIG_4.ITEM.DOT==3)
					LCD_DISINT((u16)(SCONFIG_4.ITEM.GASVAL*1000),SCONFIG_4.ITEM.DOT,ON,B8,OFF);
			}
			LCD_DISBLOCK(CH_FLAG,ON);//左侧T1-T9更新
			LCD_DISUINT(CH_FLAG);//显示单位
			if(STATE==5 || STATE==6)LCD_DISICON(ALARM,FLICK);//报警图标打开
			else LCD_DISICON(ALARM,OFF);
			if(ERRSTA>0)LCD_DISICON(ERROR,ON);//错误图标打开
			else LCD_DISICON(ERROR,OFF);
			XH_SING();//显示信号质量
			if(STATE==3)
			{
				LCD_DISSTR((const u8 *)"----",B8,OFF);
				LCD_DISSTR((const u8 *)"E-16",S8,FLICK);
			}
			else 
			{
//				LCD_DISINT((u16)(SCONFIG.ITEM.USERFULL),SCONFIG.ITEM.DOT,ON,S8,OFF);
				sprintf(data,"CH0%d",CH_FLAG+1);//显示当前修改的哪个通道
				LCD_DISSTR((const u8 *)data,S8,OFF);
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{//设置进入界面2
					DISPLAY=2;
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 2){  //密码输入界面 OK
			static u8 err=0;
			LCD_DISSTR((const u8 *)"PASS",S8,FLICK);
			LCD_DISSTR((const u8 *)"----",B8,OFF);
			if(SYSTICKCNT>500)//选中的位闪烁
			{
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]&0x0F;
			}
			else
			{
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=0;
			}
			if(err)
			{
				err=0;
				LCD_DISSTR((const u8 *)"E-10",S8,OFF);
				LCD_DISSTR((const u8 *)"----",B8,OFF);
				LCD_DISICON(ERROR,ON);
				LCD_Full(DATA);
				HAL_Delay(1000);
				LCD_DISICON(ERROR,OFF);
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=0;
				}break;
				case KEY_OK:{
					BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
					if(BitValue==CONFIG.ITEM.PASSWORD || BitValue==5819)
					{
						DISPLAY=3;
					}
					else err=1;
				}break;
				case KEY_CL:{
					DISPLAY=1;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 3){  //系统菜单界面 OK
			LCD_DISSTR((const u8 *)".SEt",S8,FLICK);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)MENU[BitSelect],B8,OFF);
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:
				case KEY_ST:{
					Ch_select=0;//传感器选择清空
					DISPLAY=4+BitSelect;
				}break;
				case KEY_CL:{
					DISPLAY=1;
				}break;
				case KEY_UP:{
					if(++BitSelect>15)BitSelect=0;
					if(BitSelect>=9 && BitSelect<=14)BitSelect=14;//if(BitSelect>=8 && BitSelect<=12)BitSelect=12
				}break;
				case KEY_DN:{
					if(BitSelect--==0)BitSelect=15;
					if(BitSelect>=9 && BitSelect<14)BitSelect=8;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==LW_CH_Select)//选择要设置哪个低报
		{
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%10);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			LCD_DISICON(SET,ON);//设置图标点亮
			//按键操作
			switch(KEYVAL)
			{
//				case KEY_ST:{
//					if(++BitSelect>3)BitSelect=0;
//				}break;
				case KEY_OK:{
					DISPLAY=41;//到低报页面
				}break;
				case KEY_CL:{
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}break;
			}
		}
		else if(DISPLAY== 41){  //S-01低报设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG.ITEM.A1*DOTMASK[SCONFIG.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_2.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_3.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_3.ITEM.A1*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_4.ITEM.A1*DOTMASK[SCONFIG_4.ITEM.DOT])%10);
				}
			}
			if(Ch_select+1 ==1)
			{
				BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			}
			if(Ch_select+1 ==2)
			{
				BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			}
			if(Ch_select+1 ==3)
			{
				BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			}
			if(Ch_select+1 ==4)
			{
				BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			}
			LCD_DISICON(SET,ON);
			sprintf(data,"CH0%d",Ch_select+1);//显示当前修改的哪个通道
			LCD_DISSTR((const u8 *)data,S8,OFF);
			if(SYSTICKCNT>500)
			{
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?20:0);
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]&0x0F;
			}
			else
			{
				
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?1:0);
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=dotadd;
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=0;
				}break;
				case KEY_OK:{
					if(Ch_select+1 ==1)
						SCONFIG.ITEM.A1=(float)(BitValue)/DOTMASK[SCONFIG.ITEM.DOT];
					if(Ch_select+1 ==2)
						SCONFIG_2.ITEM.A1=(float)(BitValue)/DOTMASK[SCONFIG_2.ITEM.DOT];
					if(Ch_select+1 ==3)
						SCONFIG_3.ITEM.A1=(float)(BitValue)/DOTMASK[SCONFIG_3.ITEM.DOT];
					if(Ch_select+1 ==4)
						SCONFIG_4.ITEM.A1=(float)(BitValue)/DOTMASK[SCONFIG_4.ITEM.DOT];
					//执行低报设置保存操作
					SETFLAG|=(1<<6);
					DISPLAY=4;
				}break;
				case KEY_CL:{
					DISPLAY=4;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==5)//选择要设置哪个高报
		{
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%10);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			LCD_DISICON(SET,ON);//设置图标点亮
			//按键操作
			switch(KEYVAL)
			{
//				case KEY_ST:{
//					if(++BitSelect>3)BitSelect=0;
//				}break;
				case KEY_OK:{
					DISPLAY=51;//到低报页面
					Bithold=0;
				}break;
				case KEY_CL:{
					Bithold=1;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}break;
			}
		}
		else if(DISPLAY== 51){  //S-02高报设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG.ITEM.A2*DOTMASK[SCONFIG.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_2.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_3.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_3.ITEM.A2*DOTMASK[SCONFIG_2.ITEM.DOT])%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT]/1000);
					bit[1]=(u8)(((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%1000)/100);
					bit[2]=(u8)(((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%100)/10);
					bit[3]=(u8)((u16)(SCONFIG_4.ITEM.A2*DOTMASK[SCONFIG_4.ITEM.DOT])%10);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			LCD_DISICON(SET,ON);
			sprintf(data,"CH0%d",Ch_select+1);//显示当前修改的哪个通道
			LCD_DISSTR((const u8 *)data,S8,OFF);
			if(SYSTICKCNT>500)
			{
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?20:0);
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]&0x0F;
			}
			else
			{
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?1:0);
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=dotadd;
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=0;
				}break;
				case KEY_OK:{
					if(Ch_select+1 ==1)
						SCONFIG.ITEM.A2=(float)(BitValue)/DOTMASK[SCONFIG.ITEM.DOT];
					if(Ch_select+1 ==2)
						SCONFIG_2.ITEM.A2=(float)(BitValue)/DOTMASK[SCONFIG_2.ITEM.DOT];
					if(Ch_select+1 ==3)
						SCONFIG_3.ITEM.A2=(float)(BitValue)/DOTMASK[SCONFIG_3.ITEM.DOT];
					if(Ch_select+1 ==4)
						SCONFIG_4.ITEM.A2=(float)(BitValue)/DOTMASK[SCONFIG_4.ITEM.DOT];
					//执行低报设置保存操作
					SETFLAG|=(1<<6);
					Bithold=1;
					DISPLAY=5;
				}break;
				case KEY_CL:{
					Bithold=1;
					DISPLAY=5;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 6){  //选择哪个S-03调零设置界面 OK
			if(Ch_select+1 ==1)
			{
				LCD_DISINT(SCONFIG.ITEM.GHEX/2,0,OFF,B8,0);
			}
			else if(Ch_select+1 ==2)
			{
				LCD_DISINT(SCONFIG_2.ITEM.GHEX/2,0,OFF,B8,0);
			}
			else if(Ch_select+1 ==3)
			{
				LCD_DISINT(SCONFIG_3.ITEM.GHEX/2,0,OFF,B8,0);
			}
			else if(Ch_select+1 ==4)
			{
				LCD_DISINT(SCONFIG_4.ITEM.GHEX/2,0,OFF,B8,0);
			}
			LCD_DISICON(CAL,ON);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					//进行调零操作
					SETFLAG|=(1<<3);
					Bithold=0;
					DISPLAY=61;
				}break;
				case KEY_CL:{
					Bithold=2;
					DISPLAY=3;
				}
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}
					break;
				default:break;
			}
		}
		else if(DISPLAY== 61){  //选择哪个S-03调零设置界面 OK
			if(Ch_select+1 ==1)
			{
				LCD_DISINT(SCONFIG.ITEM.GHEX/2,0,OFF,B8,FLICK);
			}
			else if(Ch_select+1 ==2)
			{
				LCD_DISINT(SCONFIG_2.ITEM.GHEX/2,0,OFF,B8,FLICK);
			}
			else if(Ch_select+1 ==3)
			{
				LCD_DISINT(SCONFIG_3.ITEM.GHEX/2,0,OFF,B8,FLICK);
			}
			else if(Ch_select+1 ==4)
			{
				LCD_DISINT(SCONFIG_4.ITEM.GHEX/2,0,OFF,B8,FLICK);
			}
			LCD_DISICON(CAL,ON);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,OFF);
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					//进行调零操作
					SETFLAG|=(1<<3);
					Bithold=2;
					DISPLAY=6;
				}break;
				case KEY_CL:{
					Bithold=2;
					DISPLAY=6;
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 7)////选择标定哪个界面 OK
		{
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					LCD_DISINT(SCONFIG.ITEM.GHEX,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==2)
				{
					LCD_DISINT(SCONFIG_2.ITEM.GHEX,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==3)
				{
					LCD_DISINT(SCONFIG_3.ITEM.GHEX,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==4)
				{
					LCD_DISINT(SCONFIG_4.ITEM.GHEX,0,OFF,B8,FLICK);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			LCD_DISICON(SET,ON);//设置图标点亮
			//按键操作
			switch(KEYVAL)
			{
//				case KEY_ST:{
//					if(++BitSelect>3)BitSelect=0;
//				}break;
				case KEY_OK:{
					DISPLAY=71;//到低报页面
					BitSelect=0;
					Bithold=0;
				}break;
				case KEY_CL:{
					Bithold=3;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}break;
			}
		}
		else if(DISPLAY== 71){  //S-04标定设置界面 OK
			static u8 ptr=0;
			if(ptr==0)
			{
				BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
				if(SYSTICKCNT>500)
				{
					LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]>>4;
					LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]&0x0F;
				}
				else
				{
					LCDATA[7+(3-BitSelect)*2]=0;
					LCDATA[6+(3-BitSelect)*2]=0;
				}
			}
			else
			{
				if(Ch_select+1 ==1)
				{
					LCD_DISINT(SCONFIG.ITEM.GHEX/2,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==2)
				{
					LCD_DISINT(SCONFIG_2.ITEM.GHEX/2,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==3)
				{
					LCD_DISINT(SCONFIG_3.ITEM.GHEX/2,0,OFF,B8,FLICK);
				}
				else if(Ch_select+1 ==4)
				{
					LCD_DISINT(SCONFIG_4.ITEM.GHEX/2,0,OFF,B8,FLICK);
				}
			}
			LCD_DISICON(CAL,ON);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,OFF);
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(ptr==0)
					{
						if(++BitSelect>3)BitSelect=0;
					}
				}break;
				case KEY_OK:{
					if(ptr==0)
					{
						if(Ch_select+1 ==1)
							GASADJ=(float)(BitValue)/(float)(DOTMASK[SCONFIG.ITEM.DOT]);
						if(Ch_select+1 ==2)
							GASADJ=(float)(BitValue)/(float)(DOTMASK[SCONFIG_2.ITEM.DOT]);
						if(Ch_select+1 ==3)
							GASADJ=(float)(BitValue)/(float)(DOTMASK[SCONFIG_3.ITEM.DOT]);
						if(Ch_select+1 ==4)
							GASADJ=(float)(BitValue)/(float)(DOTMASK[SCONFIG_4.ITEM.DOT]);
						ptr=1;
					}
					else
					{
						//进行标定操作
						SETFLAG|=(1<<4);
						Bithold=3;
						DISPLAY=7;
						ptr=0;
					}
				}break;
				case KEY_UP:{
					if(ptr==0)
					{
						if(++bit[BitSelect]>9)bit[BitSelect]=0;
					}
				}break;
				case KEY_DN:{
					if(ptr==0)
					{
						if(bit[BitSelect]--==0)bit[BitSelect]=9;
					}
				}break;
				case KEY_CL:{
					if(ptr==1)
					{
						ptr=0;
					}
					else
					{
						Bithold=3;
						DISPLAY=7;
					}
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 8)////选择标定哪个界面 OK
		{
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_2.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_2.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_2.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_3.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_3.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_3.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_4.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_4.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_4.ITEM.USERFULL%10);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			LCD_DISICON(SET,ON);//设置图标点亮
			//按键操作
			switch(KEYVAL)
			{
//				case KEY_ST:{
//					if(++BitSelect>3)BitSelect=0;
//				}break;
				case KEY_OK:{
					DISPLAY=81;//到低报页面
					Bithold=0;
				}break;
				case KEY_CL:{
					Bithold=4;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}break;
			}
		}
		else if(DISPLAY== 81){  //S-05量程设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				{
					bit[0]=(u8)(SCONFIG.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==2)
				{
					bit[0]=(u8)(SCONFIG_2.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_2.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_2.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_2.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==3)
				{
					bit[0]=(u8)(SCONFIG_3.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_3.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_3.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_3.ITEM.USERFULL%10);
				}
				else if(Ch_select+1 ==4)
				{
					bit[0]=(u8)(SCONFIG_4.ITEM.USERFULL/1000);
					bit[1]=(u8)((SCONFIG_4.ITEM.USERFULL%1000)/100);
					bit[2]=(u8)((SCONFIG_4.ITEM.USERFULL%100)/10);
					bit[3]=(u8)(SCONFIG_4.ITEM.USERFULL%10);
				}
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			if(Ch_select+1 ==1)
				LCD_DISINT(BitValue,SCONFIG.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==2)
				LCD_DISINT(BitValue,SCONFIG_2.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==3)
				LCD_DISINT(BitValue,SCONFIG_3.ITEM.DOT,OFF,B8,OFF);
			if(Ch_select+1 ==4)
				LCD_DISINT(BitValue,SCONFIG_4.ITEM.DOT,OFF,B8,OFF);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			LCD_DISICON(SET,ON);//设置图标点亮
			if(SYSTICKCNT>500)
			{
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?20:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?20:0);
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]+dotadd]&0x0F;
			}
			else
			{
				if(Ch_select+1 ==1)
					dotadd=((SCONFIG.ITEM.DOT>0 &&SCONFIG.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==2)
					dotadd=((SCONFIG_2.ITEM.DOT>0 &&SCONFIG_2.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==3)
					dotadd=((SCONFIG_3.ITEM.DOT>0 &&SCONFIG_3.ITEM.DOT==3-BitSelect)?1:0);
				if(Ch_select+1 ==4)
					dotadd=((SCONFIG_4.ITEM.DOT>0 &&SCONFIG_4.ITEM.DOT==3-BitSelect)?1:0);
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=dotadd;
			}
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=0;
				}break;
				case KEY_OK:{
					if(Ch_select+1 ==1)
						SCONFIG.ITEM.USERFULL=BitValue;
					if(Ch_select+1 ==2)
						SCONFIG_2.ITEM.USERFULL=BitValue;
					if(Ch_select+1 ==3)
						SCONFIG_3.ITEM.USERFULL=BitValue;
					if(Ch_select+1 ==4)
						SCONFIG_4.ITEM.USERFULL=BitValue;
					//执行量程设置保存操作
					SETFLAG|=(1<<5);
					Bithold=4;
					DISPLAY=8;
				}break;
				case KEY_CL:{
					Bithold=4;
					DISPLAY=8;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY== 9){  //S-06选择则设置哪个小数点 OK
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				BitSelect=SCONFIG.ITEM.DOT;
			if(Ch_select+1 ==2)
				BitSelect=SCONFIG_2.ITEM.DOT;
			if(Ch_select+1 ==3)
				BitSelect=SCONFIG_3.ITEM.DOT;
			if(Ch_select+1 ==4)
				BitSelect=SCONFIG_4.ITEM.DOT;
			}
			LCD_DISINT(BitSelect,0,ON,B8,OFF);
			LCD_DISICON(SET,ON);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,ON);
			switch(KEYVAL)
			{
//				case KEY_ST:{
//					if(++BitSelect>3)BitSelect=0;
//				}break;
				case KEY_OK:{
					DISPLAY=91;//到低报页面
					Bithold=0;
				}break;
				case KEY_CL:{
					Bithold=5;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++Ch_select>3)Ch_select=0;
					ReadCon=1;
				}break;
				case KEY_DN:{
					if(Ch_select--==0)Ch_select=3;
					ReadCon=1;
				}break;
			}
		}
		else if(DISPLAY== 91){  //S-06小数点设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				if(Ch_select+1 ==1)
				BitSelect=SCONFIG.ITEM.DOT;
				if(Ch_select+1 ==2)
					BitSelect=SCONFIG_2.ITEM.DOT;
				if(Ch_select+1 ==3)
					BitSelect=SCONFIG_3.ITEM.DOT;
				if(Ch_select+1 ==4)
					BitSelect=SCONFIG_4.ITEM.DOT;
			}
			LCD_DISINT(BitSelect,0,ON,B8,FLICK);
			LCD_DISICON(SET,ON);
			sprintf(data,"CH0%d",Ch_select+1);
			LCD_DISSTR((u8 *)data,S8,OFF);
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					if(Ch_select+1 ==1)
					SCONFIG.ITEM.DOT=BitSelect;
					if(Ch_select+1 ==2)
						SCONFIG_2.ITEM.DOT=BitSelect;
					if(Ch_select+1 ==3)
						SCONFIG_3.ITEM.DOT=BitSelect;
					if(Ch_select+1 ==4)
						SCONFIG_4.ITEM.DOT=BitSelect;
					//执行小数点保存操作
					SETFLAG|=(1<<2);
					Bithold=5;
					DISPLAY=9;
				}break;
				case KEY_UP:{
					if(++BitSelect>2)BitSelect=0;
				}break;
				case KEY_DN:{
					if(BitSelect--==0)BitSelect=2;
				}break;
				case KEY_CL:{
					Bithold=5;
					DISPLAY=9;
				}break;
				default:break;
			}
		}

		else if(DISPLAY==10){  //S-07密码设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				bit[0]=(u8)(CONFIG.ITEM.PASSWORD/1000);
				bit[1]=(u8)((CONFIG.ITEM.PASSWORD%1000)/100);
				bit[2]=(u8)((CONFIG.ITEM.PASSWORD%100)/10);
				bit[3]=(u8)(CONFIG.ITEM.PASSWORD%10);
			}
			BitValue=(u16)(bit[0]*1000+bit[1]*100+bit[2]*10+bit[3]);
			LCD_DISINT(BitValue,0,OFF,B8,OFF);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-07",S8,OFF);
			if(SYSTICKCNT>500)
			{
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]&0x0F;
			}
			else
			{
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=0;
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=0;
				}break;
				case KEY_OK:{
					CONFIG.ITEM.PASSWORD=BitValue;
					//执行密码设置保存操作
					SYSBIT|=(1<<5);
					Bithold=6;
					DISPLAY=3;
				}break;
				case KEY_CL:{
					Bithold=6;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==11){  //S-08总线通信地址设置界面 OK
			if(ReadCon)
			{
				ReadCon=0;
				bit[1]=(u8)((CONFIG.ITEM.ADDRESS%1000)/100);
				bit[2]=(u8)((CONFIG.ITEM.ADDRESS%100)/10);
				bit[3]=(u8)(CONFIG.ITEM.ADDRESS%10);
			}
			BitValue=(u8)(bit[1]*100+bit[2]*10+bit[3]);
			if(BitValue>=255)BitValue=255;
			LCD_DISINT(BitValue,0,OFF,B8,OFF);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-08",S8,OFF);
			if(SYSTICKCNT>500)
			{
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]&0x0F;
			}
			else
			{
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=0;
			}
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=1;
				}break;
				case KEY_OK:{
					CONFIG.ITEM.ADDRESS=BitValue;
					//执行总线通信地址设置保存操作
					SYSBIT|=(1<<5);
					Bithold=7;
					DISPLAY=3;
				}break;
				case KEY_CL:{
					Bithold=7;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==12){  //S-09   
			if(ReadCon)
			{
				ReadCon=0;
				bit[1]=(u8)((CONFIG.ITEM.Time_FY%1000)/100);
				bit[2]=(u8)((CONFIG.ITEM.Time_FY%100)/10);
				bit[3]=(u8)(CONFIG.ITEM.Time_FY%10);
			}
			BitValue=(u8)(bit[1]*100+bit[2]*10+bit[3]);
			if(BitValue>=255)BitValue=255;
			LCD_DISINT(BitValue,0,OFF,B8,OFF);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-09",S8,OFF);
			if(SYSTICKCNT>500)
			{
				LCDATA[7+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]>>4;
				LCDATA[6+(3-BitSelect)*2]=DISDIG[bit[BitSelect]]&0x0F;
			}
			else
			{
				LCDATA[7+(3-BitSelect)*2]=0;
				LCDATA[6+(3-BitSelect)*2]=0;
			}
			//按键操作
			switch(KEYVAL)
			{
				case KEY_ST:{
					if(++BitSelect>3)BitSelect=2;
				}break;
				case KEY_OK:{
					CONFIG.ITEM.Time_FY=BitValue;//取出翻页时间
					FLASH_CONFIG_WRITE();//保存翻页时间数据
					Bithold=8;
					DISPLAY=3;
				}break;
				case KEY_CL:{
					Bithold=8;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++bit[BitSelect]>9)bit[BitSelect]=0;
				}break;
				case KEY_DN:{
					if(bit[BitSelect]--==0)bit[BitSelect]=9;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==13){  //S-10
			
		}
		else if(DISPLAY==14){  //S-11
			
		}
		else if(DISPLAY==15){  //S-12
			
		}
		else if(DISPLAY==16){  //S-13输出4mA调整 OK
			static u16 tmp_4=0;
			if(ReadCon)
			{
				ReadCon=0;
				tmp_4=CONFIG.ITEM.DA4mA;
				if(tmp_4<=200)tmp_4=200;
				else if(tmp_4>=2000)tmp_4=2000;
				DEMMA=tmp_4;
			}
			LCD_DISINT(tmp_4,0,OFF,B8,FLICK);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-13",S8,OFF);
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					CONFIG.ITEM.DA4mA=tmp_4;
					//执行4mA_DAC值保存操作
					SYSBIT|=(1<<5);
					Bithold=12;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++tmp_4>2000)tmp_4=200;
					DEMMA=tmp_4;
				}break;
				case KEY_DN:{
					if(tmp_4--==200)tmp_4=2000;
					DEMMA=tmp_4;
				}break;
				case KEY_CL:{
					Bithold=12;
					DISPLAY=3;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==17){  //S-14输出20mA调整 OK
			static u16 tmp_16=0;
			if(ReadCon)
			{
				ReadCon=0;
				tmp_16=CONFIG.ITEM.DA20mA;
				if(tmp_16<=2000)tmp_16=2000;
				DEMMA=tmp_16;
			}
			LCD_DISINT(tmp_16,0,OFF,B8,FLICK);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-14",S8,OFF);
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					CONFIG.ITEM.DA20mA=tmp_16;
					//执行20mA_DAC值保存操作
					SYSBIT|=(1<<5);
					Bithold=13;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++tmp_16>4095)tmp_16=2000;
					DEMMA=tmp_16;
				}break;
				case KEY_DN:{
					if(tmp_16--==2000)tmp_16=4095;
					DEMMA=tmp_16;
				}break;
				case KEY_CL:{
					Bithold=13;
					DISPLAY=3;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==18){  //S-15探测器工作模式设置 OK
			if(ReadCon)
			{
				ReadCon=0;
				BitSelect=CONFIG.ITEM.WORKMODE;
			}
			LCD_DISINT(BitSelect,0,ON,B8,FLICK);
			LCD_DISICON(SET,ON);
			LCD_DISSTR((const u8 *)"S-15",S8,OFF);
			
			//按键操作
			switch(KEYVAL)
			{
				case KEY_OK:{
					CONFIG.ITEM.WORKMODE=BitSelect;
					//执行工作模式保存操作
					SYSBIT|=(1<<5);
					Bithold=14;
					DISPLAY=3;
				}break;
				case KEY_UP:{
					if(++BitSelect>2)BitSelect=0;
				}break;
				case KEY_DN:{
					if(BitSelect--==0)BitSelect=2;
				}break;
				case KEY_CL:{
					Bithold=14;
					DISPLAY=3;
				}break;
				default:break;
			}
		}
		else if(DISPLAY==19){  //S-16探测器自检 OK
			for(i=0;i<6;i++)
			{
				if(i%2==0)
				{
					LCD_Full(ALL);
					LED1(ON);LED2(ON);LED3(ON);LED4(ON);
					HAL_Delay(900);
				}
				else
				{
					LCD_Full(CLEAR);
					LED1(OFF);LED2(OFF);LED3(OFF);LED4(OFF);
					HAL_Delay(100);
				}
			}
			Bithold=15;
			DISPLAY=3;
		}
		
		//公共界面执行部分
		KEYVAL=0;
		if((SYSBIT&(1<<3))==0)LCD_Full(DATA);
		osDelay(10);
	}
}

void U1Task(void const * argument)  //USART1 RS485通讯任务函数    4g
{
	
	TCP_config() ;
	for(;;)
  {
		osDelay(6000);
		TCP_send();
	}
}

void U2Task(void const * argument)  //USART2 HART通讯任务函数
{
	for(;;)
  {
		
		osDelay(10);
	}
}

void U3Task(void const * argument)  //USART3 SENSOR通讯任务函数
{
	static u8 cnt=0;
	u8 i=0;
	for(;;)
  {
		if(((SYSBIT&(1<<2))>0)&& DISPLAY>0)
		{
			if(SETFLAG==0) //读取SENSOR
			{
				if(cnt++>=50)
				{
					cnt=0;
					if((ERRSTA&16)==0)
					{
						for(i=0;i<4;i++)
						{
							U3_SENSOR_CON(i,0x01,1);//读取浓度
							U3_SENSOR_CON(i,0x02,1);//读取温度
							U3_SENSOR_CON(i,0x03,1);//读取AD值
						}
					}
					else
					{
						for(i=0;i<4;i++)
						{
							U3_SENSOR_CON(i,0xFF,1);
							U3_SENSOR_CON(i,0x01,1);
						}
					}
				}
			}
			else           //设置SENSOR
			{
				if(SETFLAG&(1<<0))//设置SENSOR单位
				{
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<0);
				}
				if(SETFLAG&(1<<1))//设置SENSOR气体类型
				{
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<1);
				}
				if(SETFLAG&(1<<2))//设置SENSOR小数点
				{
					U3_SENSOR_CON(Ch_select,0x21,1);
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<2);
				}
				if(SETFLAG&(1<<3))//设置SENSOR普通调零
				{
					U3_SENSOR_CON(Ch_select,0x26,1);
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<3);
				}
				if(SETFLAG&(1<<4))//设置SENSOR标定增益
				{
					U3_SENSOR_CON(Ch_select,0x27,1);
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<4);
				}
				if(SETFLAG&(1<<5))//设置SENSOR用户量程
				{
					U3_SENSOR_CON(Ch_select,0x20,1);
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<5);
				}
				if(SETFLAG&(1<<6))//设置SENSOR报警点
				{
					U3_SENSOR_CON(Ch_select,0x23,1);
					U3_SENSOR_CON(Ch_select,0x28,1);
					SETFLAG&=~(1<<6);
				}
			}
		}
		osDelay(10);
	}
}
3.功能函数
#include "define.h"
#include "math.h"

//=============================其他控制函数====================================//
void Delay_us(u16 cnt)
{
	u16 i=0,j=0;
	for(i=0;i<cnt;i++)
	{
		for(j=0;j<24;j++);
	}
}

u8 CheckSum(u8 *i,u8 l)//RS485通讯校验函数
{
	u8 j,tempq=0;
	i+=1;
	for(j=0;j<(l-2);j++)
	{
		tempq+=*i;
		i++;
	}
	tempq=(~tempq)+1;
	return(tempq);
}

void DETECTOR_STATE_CON(void)//探测器状态监测函数
{
	//状态计算
	if(ERRSTA&0x10)//存在传感器故障状态时
	{
		STATE=3;//传感器故障状态
	}
	else  //SCONFIG_3.ITEM.
	{
		//第一个传感器
		if(GZ[0][0]==1 || CONFIG.ITEM.add[0]==0)
			SCONFIG.ITEM.STATE=3;
		else if(SCONFIG.ITEM.NAMECODE==0 ||SCONFIG.ITEM.NAMECODE==5 )//氧气
		{
			if(SCONFIG.ITEM.GASVAL>=SCONFIG.ITEM.A2 )
			{
				SCONFIG.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if(SCONFIG.ITEM.GASVAL<=SCONFIG.ITEM.A1)
			{
				SCONFIG.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else SCONFIG.ITEM.STATE=1;//正常状态
		}
		else//正常高低报
		{
			if(SCONFIG.ITEM.GASVAL>=SCONFIG.ITEM.A2)
			{
				SCONFIG.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if((SCONFIG.ITEM.GASVAL>=SCONFIG.ITEM.A1 && SCONFIG.ITEM.GASVAL<SCONFIG.ITEM.A2))
			{
				SCONFIG.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else
			{
				SCONFIG.ITEM.STATE=1;//正常状态
			}
		}
		//第二个传感器判断
		if(GZ[1][0]==1 || CONFIG.ITEM.add[1]==0)
			SCONFIG_2.ITEM.STATE=3;
		else if(SCONFIG_2.ITEM.NAMECODE==0 ||SCONFIG_2.ITEM.NAMECODE==5 )//氧气
		{
			if(SCONFIG_2.ITEM.GASVAL>=SCONFIG_2.ITEM.A2 )
			{
				SCONFIG_2.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if(SCONFIG_2.ITEM.GASVAL<=SCONFIG_2.ITEM.A1)
			{
				SCONFIG_2.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else SCONFIG_2.ITEM.STATE=1;//正常状态
		}
		else//正常高低报
		{
			if(SCONFIG_2.ITEM.GASVAL>=SCONFIG_2.ITEM.A2)
			{
				SCONFIG_2.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if((SCONFIG_2.ITEM.GASVAL>=SCONFIG_2.ITEM.A1 && SCONFIG_2.ITEM.GASVAL<SCONFIG_2.ITEM.A2))
			{
				SCONFIG_2.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else
			{
				SCONFIG_2.ITEM.STATE=1;//正常状态
			}
		}
		//第3个传感器判断
		if(GZ[2][0]==1 || CONFIG.ITEM.add[2]==0)
			SCONFIG_3.ITEM.STATE=3;
		else if(SCONFIG_3.ITEM.NAMECODE==0 ||SCONFIG_3.ITEM.NAMECODE==5 )//氧气
		{
			
			if(SCONFIG_3.ITEM.GASVAL>=SCONFIG_3.ITEM.A2 )
			{
				SCONFIG_3.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if(SCONFIG_3.ITEM.GASVAL<=SCONFIG_3.ITEM.A1)
			{
				SCONFIG_3.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else SCONFIG_3.ITEM.STATE=1;//正常状态
		}
		else//正常高低报
		{
			if(SCONFIG_3.ITEM.GASVAL>=SCONFIG_3.ITEM.A2)
			{
				SCONFIG_3.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if((SCONFIG_3.ITEM.GASVAL>=SCONFIG_3.ITEM.A1 && SCONFIG_3.ITEM.GASVAL<SCONFIG_3.ITEM.A2))
			{
				SCONFIG_3.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else
			{
				SCONFIG_3.ITEM.STATE=1;//正常状态
			}
		}
			//第4个传感器判断
		if(GZ[3][0]==1 || CONFIG.ITEM.add[3]==0)
			SCONFIG_4.ITEM.STATE=3;
		else if(SCONFIG_4.ITEM.NAMECODE==0 ||SCONFIG_4.ITEM.NAMECODE==5 )//氧气
		{
			if(SCONFIG_4.ITEM.GASVAL>=SCONFIG_4.ITEM.A2 )
			{
				SCONFIG_4.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if(SCONFIG_4.ITEM.GASVAL<=SCONFIG_4.ITEM.A1)
			{
				SCONFIG_4.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else SCONFIG_4.ITEM.STATE=1;//正常状态
		}
		else//正常高低报
		{
			if(SCONFIG_4.ITEM.GASVAL>=SCONFIG_4.ITEM.A2)
			{
				SCONFIG_4.ITEM.STATE=6;
				STATE=6;//高报状态
			}
			else if((SCONFIG_4.ITEM.GASVAL>=SCONFIG_4.ITEM.A1 && SCONFIG_4.ITEM.GASVAL<SCONFIG_4.ITEM.A2))
			{
				SCONFIG_4.ITEM.STATE=5;
				STATE=5;//低报状态
			}
			else
			{
				SCONFIG_4.ITEM.STATE=1;//正常状态
			}
		}
		if((SCONFIG.ITEM.STATE==1 || CONFIG.ITEM.add[0]==0)&&(SCONFIG_2.ITEM.STATE==1 || CONFIG.ITEM.add[1]==0) && (SCONFIG_3.ITEM.STATE==1 || CONFIG.ITEM.add[2]==0)&& (SCONFIG_4.ITEM.STATE==1 || CONFIG.ITEM.add[3]==0))//四个都正常才正常
		{
			STATE=1;//正常状态
		}
		else if((SCONFIG.ITEM.STATE==3 || CONFIG.ITEM.add[0]==0) && (SCONFIG_2.ITEM.STATE==3|| CONFIG.ITEM.add[1]==0) && (SCONFIG_3.ITEM.STATE==3|| CONFIG.ITEM.add[3]==0)&& (SCONFIG_4.ITEM.STATE==3|| CONFIG.ITEM.add[0]==0))//四个都异常才议异常
		{
			STATE=3;//异常状态
		}
	}
	
	//LED指示灯控制
	if(DISPLAY!=0 && DISPLAY!=19)
	{
		if(SCONFIG.ITEM.NAMECODE==0 ||SCONFIG.ITEM.NAMECODE==5)//氧气
		{
			if(STATE==5)LED2(ON);
			else LED2(OFF);
		}
		else
		{
			if(STATE==5 || STATE==6)LED2(ON);
			else LED2(OFF);
		}
		
		if(STATE==6)LED3(ON);
		else LED3(OFF);
		
		if(ERRSTA)LED4(ON);
		else LED4(OFF);
	}
	
  //声光报警器控制
	if(DISPLAY!=0 && DISPLAY!=19)
	{
		if(STATE==5)
		{
			SGBJ_K(ON);SGBJ_S(OFF);
		}
		else if(STATE==6)
		{
			SGBJ_K(ON);SGBJ_S(ON);
		}
		else
		{
			SGBJ_K(OFF);SGBJ_S(OFF);
		}
	}
	
	//节点输出控制
	
}

void DAC_OUTPUT_CON(u8 mode) //DAC1输出控制函数
{
	u32 tmp=0;
	if(mode==0)//关闭DAC1
	{
//		HAL_DAC_Stop(&hdac,DAC_CHANNEL_1);//停止输出DAC1
	}
	else
	{
		if(mode==1)//正常输出模式
		{
			if(ERRSTA&0x16)//存在传感器故障
			{
				tmp=373;//输出2mA
			}
			else
			{
				tmp=(CONFIG.ITEM.DA20mA-CONFIG.ITEM.DA4mA)*SCONFIG.ITEM.GASVAL/SCONFIG.ITEM.USERFULL+CONFIG.ITEM.DA4mA;//根据示值输出4~20mA信号
			}
		}
		else if(mode==2)
		{
			tmp=DEMMA;
		}
//		HAL_DAC_SetValue(&hdac,DAC_CHANNEL_1,DAC_ALIGN_12B_R,tmp);
//		HAL_DAC_Start(&hdac,DAC_CHANNEL_1);//开始输出DAC1
	}
}

void FLASH_CONFIG_WRITE(void)
{
	u32 FLASH_END_ADDR=FLASH_START_ADDR+26;
	u32 TEMP[7];
	u32 CURRENTADDR;
	u8 i=0;
	HAL_StatusTypeDef FLASHStatus=HAL_OK;
	FLASH_EraseInitTypeDef My_Flash;
	u32 PageError = 0;
	
	//封装配置参数
	TEMP[0]=CONFIG.ITEM.ID;
	TEMP[1]=CONFIG.ITEM.ADDRESS |(CONFIG.ITEM.WORKMODE<<8)|(CONFIG.ITEM.VER<<16)|(CONFIG.ITEM.BAUDCODE<<24);
	TEMP[2]=CONFIG.ITEM.OUTMODE |(CONFIG.ITEM.OUTDLY<<8)|(CONFIG.ITEM.BKDATA0<<16)|(CONFIG.ITEM.BKDATA1<<24);
	TEMP[3]=CONFIG.ITEM.DA4mA |(CONFIG.ITEM.DA20mA<<16);
	TEMP[4]=CONFIG.ITEM.PASSWORD |(CONFIG.ITEM.BKDATA2<<16);
	TEMP[5]=CONFIG.ITEM.add[0]|CONFIG.ITEM.add[1]|CONFIG.ITEM.add[2]|CONFIG.ITEM.add[3];
	TEMP[6]=(u32)CONFIG.ITEM.Time_FY;
	
	HAL_FLASH_Unlock();
	My_Flash.TypeErase = FLASH_TYPEERASE_PAGES;
	My_Flash.PageAddress = FLASH_START_ADDR;
	My_Flash.NbPages = 1;
	
	HAL_FLASHEx_Erase(&My_Flash, &PageError);
	CURRENTADDR=FLASH_START_ADDR;
	while(CURRENTADDR<FLASH_END_ADDR && FLASHStatus==HAL_OK)
	{
		FLASHStatus=HAL_FLASH_Program(FLASH_TYPEPROGRAM_WORD, CURRENTADDR, TEMP[i++]);
		CURRENTADDR+=4;
	}
	HAL_FLASH_Lock(); 
}

void FLASH_CONFIG_READ(void)
{
	u32 FLASH_END_ADDR=FLASH_START_ADDR+26;
	u32 TEMP[7];
	u32 CURRENTADDR;
	u8 i=0;
	
	CURRENTADDR=FLASH_START_ADDR;
	while(CURRENTADDR<FLASH_END_ADDR)
	{
		TEMP[i++]=*(u32*)(CURRENTADDR);
		CURRENTADDR+=4;
	}
	
	if((TEMP[2]>>16)!=0xA5)  //参数未初始化
	{
		CONFIG.ITEM.ID=1;
		CONFIG.ITEM.ADDRESS=1;
		CONFIG.ITEM.WORKMODE=0;
		CONFIG.ITEM.VER=10;
		CONFIG.ITEM.BAUDCODE=0;
		CONFIG.ITEM.OUTMODE=0;
		CONFIG.ITEM.OUTDLY=0;
		CONFIG.ITEM.BKDATA0=0xA5;
		CONFIG.ITEM.BKDATA1=0;
		CONFIG.ITEM.DA4mA=770;
		CONFIG.ITEM.DA20mA=3765;
		CONFIG.ITEM.PASSWORD=1000;
		CONFIG.ITEM.BKDATA2=0;
		FLASH_CONFIG_WRITE();
	}
	else
	{
		CONFIG.ITEM.ID=TEMP[0];
		CONFIG.ITEM.ADDRESS=TEMP[1];
		CONFIG.ITEM.WORKMODE=(TEMP[1]>>8);
		CONFIG.ITEM.VER=(TEMP[1]>>16);
		CONFIG.ITEM.BAUDCODE=(TEMP[1]>>24);
		CONFIG.ITEM.OUTMODE=TEMP[2];
		CONFIG.ITEM.OUTDLY=(TEMP[2]>>8);
		CONFIG.ITEM.BKDATA0=(TEMP[2]>>16);
		CONFIG.ITEM.BKDATA1=(TEMP[2]>>24);
		CONFIG.ITEM.DA4mA=TEMP[3];
		CONFIG.ITEM.DA20mA=(TEMP[3]>>16);
		CONFIG.ITEM.PASSWORD=TEMP[4];
		CONFIG.ITEM.BKDATA2=(TEMP[4]>>16);
//		CONFIG.ITEM.add[0]=(TEMP[5]>>24);
//		CONFIG.ITEM.add[1]=(TEMP[5]>>16);
//		CONFIG.ITEM.add[2]=(TEMP[5]>>8);
//		CONFIG.ITEM.add[3]=TEMP[5];
		CONFIG.ITEM.Time_FY=TEMP[6];
	}
}

void PARA_CONFIG_LOAD(void)//读取参数配置
{
	u8 loop=10,i=0;
	//读取配置数据
	FLASH_CONFIG_READ();
	if(CONFIG.ITEM.add[0]!=0 && CONFIG.ITEM.add[1]!=0 && CONFIG.ITEM.add[2]!=0 && CONFIG.ITEM.add[3]!=0)
		Add_ready_flag=1;//地址已准备好
	if(CONFIG.ITEM.Time_FY==0)
		CONFIG.ITEM.Time_FY=2;//默认2S
	//读取传感器参数配置
	do{
		HAL_IWDG_Refresh(&hiwdg);  //喂狗
		if(Add_ready_flag==0)//没有地址数据
			for(i=1;i<0x10;i++)//4e
			{
//				U3_SENSOR_CON(i,0xFF,0);
				U3_SENSOR_CON(i,0x04,0);//读取量程
				HAL_Delay(50);
			}
		else//有地址数据
			for(i=0;i<4;i++)
			{
//				U3_SENSOR_CON(i,0xFF,1);
				U3_SENSOR_CON(i,0x04,1);//读取量程
				HAL_Delay(50);
			}
		if(SYSBIT&(1<<4))break;
	}while(loop--);
	Add_ready_flag=1;//强制地址准备好，因为有可能只扫描到三个探头
	if(SYSBIT&(1<<4))
	{
		for(i=0;i<4;i++)
		{
			U3_SENSOR_CON(i,0x05,1);//读取小数点
			HAL_Delay(50);
			U3_SENSOR_CON(i,0x07,1);//读取报警点
			HAL_Delay(50);
			U3_SENSOR_CON(i,0x09,1);//读取单位代码
			HAL_Delay(50);
			U3_SENSOR_CON(i,0x0B,1);//读取气体名称代码
			HAL_Delay(50);
			U3_SENSOR_CON(i,0x0C,1);//读取模块ID
			HAL_Delay(50);
			U3_SENSOR_CON(i,0x0D,1);//读取模块版本号
			HAL_Delay(50);
		}
	}
	else
	{
		ERRSTA|=16;//传感器故障置位
	}
	
}



//=============================DISPLAY驱动函数==================================//
void LCD_GPIO_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	__HAL_RCC_GPIOA_CLK_ENABLE();
	__HAL_RCC_GPIOB_CLK_ENABLE();
	
	GPIO_InitStruct.Pin = GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
	
	GPIO_InitStruct.Pin = GPIO_PIN_13;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
	
}


void SendBit_1621(u8 data,u8 cnt)
{
	u8 i;
	for(i=0;i<cnt;i++)
	{
		LCD_WR_0;
		Delay_us(5);
		if((data&0x80)==0)
		{
			LCD_DA_0;
		}
		else
		{
			LCD_DA_1;
		}
		Delay_us(5);
		LCD_WR_1;
		Delay_us(5);
		data<<=1;
	}
}

void SendDataBit_1621(u8 data,u8 cnt)
{
	u8 i;
	for(i=0;i<cnt;i++)
	{
		LCD_WR_0;
		Delay_us(5);
		if((data&0x01)==0)
		{
			LCD_DA_0;
		}
		else
		{
			LCD_DA_1;
		}
		Delay_us(5);
		LCD_WR_1;
		Delay_us(5);
		data>>=1;
	}
}

void SendCmd(u8 cmmand)
{
	LCD_CS_0;
	Delay_us(2);
//	SendBit_1621(0x80,3);
//	SendBit_1621(cmmand,8);
//	SendBit_1621(0x00,1);
	SendBit_1621(0x80,4);
	SendBit_1621(cmmand,8);
	Delay_us(2);
	LCD_CS_1;
	Delay_us(2);
}

void LCD_Write(u8 addr,u8 data)
{
	LCD_CS_0;
	Delay_us(2);
	SendBit_1621(0xA0,3);
	SendBit_1621(addr<<2,6);
	SendDataBit_1621(data,4);
	Delay_us(2);
	LCD_CS_1;
	Delay_us(2);
}
//LCD数据全部更新函数
void LCD_Full(u8 data)
{
	u8 i;
	for(i=0;i<23;i++)
	{
		if(data==0)LCDATA[i]=0;
		else if(data==1)LCDATA[i]=0xFF;
		LCD_Write(i,LCDATA[i]);
	}
}

void LCD_Config(void)
{
	LCD_CS_1;
	LCD_WR_1;
	LCD_DA_1;
	HAL_Delay(10);
	
	SendCmd(BIAS); 
	SendCmd(RC256);
	SendCmd(SYSDIS);
	SendCmd(WDTDIS);
	SendCmd(SYSEN); 
	SendCmd(LCDON);
	LCD_Full(0);
	
}

//有符号数显示
void LCDS8DIS(u8 num,u8 data)
{
	u8 i;
	for(i=0;i<8;i++)
	{
		switch(i)
		{
			case 0:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[18]&=~(1<<1);
					else LCDATA[18]|=(1<<1);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[15]&=~(1<<1);
					else LCDATA[15]|=(1<<1);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[1]&=~(1<<1);
					else LCDATA[1]|=(1<<1);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[3]&=~(1<<1);
					else LCDATA[3]|=(1<<1);
				}
			}break;
			case 1:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[19]&=~(1<<1);
					else LCDATA[19]|=(1<<1);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[16]&=~(1<<1);
					else LCDATA[16]|=(1<<1);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[0]&=~(1<<1);
					else LCDATA[0]|=(1<<1);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[2]&=~(1<<1);
					else LCDATA[2]|=(1<<1);
				}
			}break;
			case 2:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[19]&=~(1<<2);
					else LCDATA[19]|=(1<<2);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[17]&=~(1<<2);
					else LCDATA[17]|=(1<<2);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[14]&=~(1<<2);
					else LCDATA[14]|=(1<<2);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[2]&=~(1<<2);
					else LCDATA[2]|=(1<<2);
				}
			}break;
			case 3:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[19]&=~(1<<3);
					else LCDATA[19]|=(1<<3);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[16]&=~(1<<3);
					else LCDATA[16]|=(1<<3);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[0]&=~(1<<3);
					else LCDATA[0]|=(1<<3);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[3]&=~(1<<3);
					else LCDATA[3]|=(1<<3);
				}
			}break;
			case 4:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[17]&=~(1<<1);
					else LCDATA[17]|=(1<<1);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[15]&=~(1<<2);
					else LCDATA[15]|=(1<<2);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[1]&=~(1<<2);
					else LCDATA[1]|=(1<<2);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[4]&=~(1<<1);
					else LCDATA[4]|=(1<<1);
				}
			}break;
			case 5:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[18]&=~(1<<2);
					else LCDATA[18]|=(1<<2);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[16]&=~(1<<2);
					else LCDATA[16]|=(1<<2);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[0]&=~(1<<2);
					else LCDATA[0]|=(1<<2);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[3]&=~(1<<2);
					else LCDATA[3]|=(1<<2);
				}
			}break;
			case 6:{
				if(num==5)
				{
					if(((data<<i)&0x80)==0)LCDATA[18]&=~(1<<3);
					else LCDATA[18]|=(1<<3);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[15]&=~(1<<3);
					else LCDATA[15]|=(1<<3);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[1]&=~(1<<3);
					else LCDATA[1]|=(1<<3);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[4]&=~(1<<2);
					else LCDATA[4]|=(1<<2);
				}
			}break;
			case 7:{
				if(num==5)
				{
					if(((data<<i)&0x01)==0)LCDATA[17]&=~(1<<3);
					else LCDATA[17]|=(1<<3);
				}
				else if(num==6)
				{
					if(((data<<i)&0x80)==0)LCDATA[14]&=~(1<<3);
					else LCDATA[14]|=(1<<3);
				}
				else if(num==7)
				{
					if(((data<<i)&0x80)==0)LCDATA[2]&=~(1<<3);
					else LCDATA[2]|=(1<<3);
				}
				else if(num==8)
				{
					if(((data<<i)&0x80)==0)LCDATA[4]&=~(1<<3);
					else LCDATA[4]|=(1<<3);
				}
			}break;
			default:break;
		}
	}
}
//VAL:数值 
//dot 小数点位数
//sta:没有数字的位置消瘾（显示空）
//pos:0:1234更新  1:5678区域更新
//flic:可闪烁
void LCD_DISINT(short val,u8 dots,u8 sta,u8 pos,u8 flic)
{
	u8 fu=0,i=0;
	u8 dis[4]={12,12,12,12};
//	short intval=val*pow(10,dots);
	short intval=val;
	if(intval<0){intval=0-intval;fu=1;}//取出个十百千位值
	dis[3]=intval/1000;
	intval%=1000;
	dis[2]=intval/100;
	intval%=100;
	dis[1]=intval/10;
	dis[0]=intval%10;
	if(fu==0)//正值
	{
		if(sta)//使能消隐?
		{
			if(dis[3]==0&&dots<3)
			{
				dis[3]=12;	//消隐 
				if(dis[2]==0&&dots<2)
				{
					dis[2]=12;	//消隐
					if(dis[1]==0&&dots<1)
					{
						dis[1]=12;//消隐
					}
				}
			}
		}
	}
	else//负值
	{
		if(dis[3]>0||dots>2)
		{
			dis[3]=11;	//-
			dis[3]=11;	//-
			dis[3]=11;	//-
			dis[3]=11;	//-
		}
		else 
		{
			if(dots==0)
			{
				if(dis[2]>0)
				{
					dis[3]=11;	//-
				}
				else if(sta)//使能消隐?
				{
					if(dis[1]>0)
					{
						dis[3]=12;	//消隐
						dis[2]=11;	//-
					}
					else
					{
						dis[3]=12;	//消隐
						dis[2]=12;	//消隐
						dis[1]=11;	//-
					}
				}
			}
			else if(dots==1)
			{
				if(dis[2]>0)
				{
					dis[3]=11;	//-
				}
				else if(sta)
				{
					dis[3]=12;	//消隐
					dis[2]=11;	//-
				}
			}
			else if(dots==2)
			{
				dis[3]=11;	//-
			}
		}
	}
	if(dots>0 && dots<=3)
	{
		if(dis[dots]<10)
		{
			dis[dots]+=20;
		}
	}
	
	for(i=0;i<4;i++)//四个数字显示区  0对应低四个数   3对应第一个数
	{
		if(pos==0)//1234区更新
		{
			if(flic==0)
			{
				LCDATA[7+i*2]=DISDIG[dis[i]]>>4;
				LCDATA[6+i*2]=DISDIG[dis[i]]&0x0F;
			}
			else
			{
				if(SYSTICKCNT>500)
				{
					LCDATA[7+i*2]=DISDIG[dis[i]]>>4;
					LCDATA[6+i*2]=DISDIG[dis[i]]&0x0F;
				}
				else
				{
					LCDATA[7+i*2]=0;
					LCDATA[6+i*2]=0;
				}
			}
		}
		else//5678区更新
		{
			if(flic==0)
			{
				LCDS8DIS(5+i,DISDIG[dis[3-i]]);
			}
			else
			{
				if(SYSTICKCNT>500)
				{
					LCDS8DIS(5+i,DISDIG[dis[3-i]]);
				}
				else
				{
					LCDS8DIS(5+i,0);
				}
			}
		}
	}
}
//LCD字符串显示函数
void LCD_DISSTR(const u8 *ptr,u8 pos,u8 flic)
{
	u8 bit=0,i;
	u8 dis[4]={12,12,12,12};
	while(*ptr && bit<4)
	{
		switch(*ptr)
		{
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':		dis[bit]=*ptr-'0';	break;
			case 'H':		dis[bit]=10;				break;
			case '-':		dis[bit]=11;				break;
			case '.':		dis[bit]=12;				break;
			case 'S':		dis[bit]=5;				  break;
			case 'E':		dis[bit]=13;				break;
			case 'F':		dis[bit]=14;				break;
			case 'd':		dis[bit]=15;				break;
			case 'P':		dis[bit]=16;				break;
			case 'r':		dis[bit]=17;				break;
			case 'A':		dis[bit]=18;				break;
			case 't':		dis[bit]=19;				break;
			case 'C':		dis[bit]=30;				break;
		}
		bit++;
		ptr++;
	}
	
	for(i=0;i<4;i++)
	{
		if(pos==0)//是上面还是下面小字
		{
			if(flic==0)
			{
				LCDATA[7+i*2]=DISDIG[dis[3-i]]>>4;
				LCDATA[6+i*2]=DISDIG[dis[3-i]]&0x0F;
			}
			else
			{
				if(SYSTICKCNT>500)
				{
					LCDATA[7+i*2]=DISDIG[dis[3-i]]>>4;
					LCDATA[6+i*2]=DISDIG[dis[3-i]]&0x0F;
				}
				else
				{
					LCDATA[7+i*2]=0;
					LCDATA[6+i*2]=0;
				}
			}
		}
		else
		{
			if(flic==0)
			{
				LCDS8DIS(5+i,DISDIG[dis[i]]);
			}
			else
			{
				if(SYSTICKCNT>500)
				{
					LCDS8DIS(5+i,DISDIG[dis[i]]);
				}
				else
				{
					LCDS8DIS(5+i,0);
				}
			}
		}
	}
}

void LCD_DISICON(u8 id,u8 sta)
{
	if(sta==0)
	{
		LCDATA[id/10]&=~(id%10);
	}
	else if(sta==1)
	{
		LCDATA[id/10]|=id%10;
	}
	else
	{
		if(SYSTICKCNT>500)LCDATA[id/10]&=~(id%10);
		else LCDATA[id/10]|=id%10;
	}
}
//加强版图标显示，能处理10以上
void LCD_DISICON_storng(u8 id,u8 sta)
{
	if(sta==0)
	{
		LCDATA[id/10-1]&=~(id%100);
	}
	else if(sta==1)
	{
		LCDATA[id/10-1]|=id%100;
	}
//	else
//	{
//		if(SYSTICKCNT>500)LCDATA[id/10]&=~(id%10);
//		else LCDATA[id/10]|=id%10;
//	}
}
//左侧T1-T9对应更新
void LCD_DISBLOCK(u8 ch,u8 a)
{
	u8 level=0;
	if(a==0)
	{
		LCDATA[19]&=~0x01;
		LCDATA[18]&=~0x01;
		LCDATA[17]&=~0x01;
		LCDATA[16]&=~0x01;
		LCDATA[15]&=~0x01;
		LCDATA[14]&=~0x01;
		LCDATA[0]&=~0x01;
		LCDATA[1]&=~0x01;
		LCDATA[2]&=~0x01;
	}
	else
	{
		if(ch==0)
			level=(u8)(SCONFIG.ITEM.GASVAL*10/(float)(SCONFIG.ITEM.USERFULL));
		else if(ch==1)
			level=(u8)(SCONFIG_2.ITEM.GASVAL*10/(float)(SCONFIG_2.ITEM.USERFULL));
		else if(ch==2)
			level=(u8)(SCONFIG_3.ITEM.GASVAL*10/(float)(SCONFIG_3.ITEM.USERFULL));
		else if(ch==3)
			level=(u8)(SCONFIG_4.ITEM.GASVAL*10/(float)(SCONFIG_4.ITEM.USERFULL));
		if(level>10)level=10;
		if(level>=1)LCDATA[2]|=0x01;
		else LCDATA[2]&=~0x01;
		if(level>=2)LCDATA[1]|=0x01;
		else LCDATA[1]&=~0x01;
		if(level>=3)LCDATA[0]|=0x01;
		else LCDATA[0]&=~0x01;
		if(level>=4)LCDATA[14]|=0x01;
		else LCDATA[14]&=~0x01;
		if(level>=5)LCDATA[15]|=0x01;
		else LCDATA[15]&=~0x01;
		if(level>=6)LCDATA[16]|=0x01;
		else LCDATA[16]&=~0x01;
		if(level>=7)LCDATA[17]|=0x01;
		else LCDATA[17]&=~0x01;
		if(level>=8)LCDATA[18]|=0x01;
		else LCDATA[18]&=~0x01;
		if(level>=9)LCDATA[19]|=0x01;
		else LCDATA[19]&=~0x01;
	}
}

void LCD_DISUINT(u8 ch)
{
	u8 data=0;
	if(ch==0)
	{
		if(SCONFIG.ITEM.UNITCODE>=1 && SCONFIG.ITEM.UNITCODE<=3)data=SCONFIG.ITEM.UNITCODE-1;
		else if(SCONFIG.ITEM.UNITCODE==5)data=3;
		else data=2;
	}
	else if(ch==1)
	{
		if(SCONFIG_2.ITEM.UNITCODE>=1 && SCONFIG_2.ITEM.UNITCODE<=3)data=SCONFIG_2.ITEM.UNITCODE-1;
		else if(SCONFIG_2.ITEM.UNITCODE==5)data=3;
		else data=2;
	}
	else if(ch==2)
	{
		if(SCONFIG_3.ITEM.UNITCODE>=1 && SCONFIG_3.ITEM.UNITCODE<=3)data=SCONFIG_3.ITEM.UNITCODE-1;
		else if(SCONFIG_3.ITEM.UNITCODE==5)data=3;
		else data=2;
	}
	else if(ch==3)
	{
		if(SCONFIG_4.ITEM.UNITCODE>=1 && SCONFIG_4.ITEM.UNITCODE<=3)data=SCONFIG_4.ITEM.UNITCODE-1;
		else if(SCONFIG_4.ITEM.UNITCODE==5)data=3;
		else data=2;
	}
	LCDATA[5]=(1<<(3-data));
}



//=============================SENSOR通讯函数===================================//
//气体名称代码打头当做地址

//ch:第几个传感器 
//form：地址从哪里取数据  1从congfig地址数组中  0：CH即地址数据
void U3_SENSOR_CON(u8 ch,u8 cmd,u8 From)
{
	u8 i;
	static u8 comcnt=0,add_count=0;
	u16 JY=0;
	DATASHIFT tmp;
	memset(U3RXBUF,0,sizeof(U3RXBUF));
	switch(cmd)
	{
		case 0x01:{//读取浓度
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			
			if(U3TXBUF[0]!=0 && U3TXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
				if(GZ[0][1]++>10)//发送次数++
						GZ[0][0]=1;//故障
			if(U3TXBUF[0]!=0 && U3TXBUF[0]==CONFIG.ITEM.add[1])//是第一个传感器
				if(GZ[1][1]++>10)//发送次数++
						GZ[1][0]=1;//故障
			if(U3TXBUF[0]!=0 && U3TXBUF[0]==CONFIG.ITEM.add[2])//是第一个传感器
				if(GZ[2][1]++>10)//发送次数++
						GZ[2][0]=1;//故障
			if(U3TXBUF[0]!=0 && U3TXBUF[0]==CONFIG.ITEM.add[3])//是第一个传感器
				if(GZ[3][1]++>10)//发送次数++
						GZ[3][0]=1;//故障
			if(U3TXBUF[0]!=0)
				HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if((ERRSTA&16)==0)
			{
				if(comcnt++>=10)ERRSTA|=16;//传感器故障置位
			}
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(U3RXBUF[1]==cmd && tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					comcnt=0;
					ERRSTA&=~(16);//传感器故障恢复
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					tmp.BYTE[2]=U3RXBUF[4];
					tmp.BYTE[3]=U3RXBUF[5];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
					{
						GZ[0][1]=0;//发送次数清空
						GZ[0][0]=0;//无故障
						SCONFIG.ITEM.GASVAL=tmp.FLOAT;//联合
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
					{
						GZ[1][1]=0;//发送次数清空
						GZ[1][0]=0;//无故障
						SCONFIG_2.ITEM.GASVAL=tmp.FLOAT;//联合
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
					{
						GZ[2][1]=0;//发送次数清空
						GZ[2][0]=0;//无故障
						SCONFIG_3.ITEM.GASVAL=tmp.FLOAT;//联合
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
					{
						GZ[3][1]=0;//发送次数清空
						GZ[2][0]=0;//无故障
						SCONFIG_4.ITEM.GASVAL=tmp.FLOAT;//联合
					}
				}
			}
		}break;
		case 0x02:{//读取温度
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(U3RXBUF[1]==cmd && tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					tmp.BYTE[2]=U3RXBUF[4];
					tmp.BYTE[3]=U3RXBUF[5];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.TEMVAL=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.TEMVAL=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.TEMVAL=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.TEMVAL=tmp.FLOAT;
				}
			}
		}break;
		case 0x03:{//读取浓度及温度AD值
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(U3RXBUF[1]==0x03 && tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					tmp.BYTE[2]=U3RXBUF[4];
					tmp.BYTE[3]=U3RXBUF[5];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
					{
						SCONFIG.ITEM.GHEX = tmp.SHORT[0];
						SCONFIG.ITEM.THEX = tmp.SHORT[1];
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
					{
						SCONFIG_2.ITEM.GHEX=tmp.SHORT[0];
						SCONFIG_2.ITEM.THEX = tmp.SHORT[1];
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
					{
						SCONFIG_3.ITEM.GHEX=tmp.SHORT[0];
						SCONFIG_3.ITEM.THEX = tmp.SHORT[1];
					}
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
					{
						SCONFIG_4.ITEM.GHEX=tmp.SHORT[0];
						SCONFIG_4.ITEM.THEX = tmp.SHORT[1];
					}
				}
			}
		}break;
		case 0x04:{//读取用户量程
			if(From==1)
				U3TXBUF[0]=CONFIG.ITEM.add[ch];
			else U3TXBUF[0]=ch;
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_IT(&huart3,U3RXBUF,1);U3BUF
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)
				{
					tmp.SHORT[0]+=U3RXBUF[i];
				}//计算校验和
				if(U3RXBUF[1]==cmd && tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					if(Add_ready_flag==0)
						CONFIG.ITEM.add[add_count++]=U3RXBUF[0];//记录地址
					if(add_count>3 && Add_ready_flag==0) 
					{
						Add_ready_flag=1;//地址已准备完毕
//						FLASH_CONFIG_WRITE();//保存数据
					}
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.USERFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.USERFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.USERFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.USERFULL=tmp.SHORT[0];
					SYSBIT|=(1<<4);
				}
			}
		}break;
		case 0x05:{//读取小数点
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.DOT=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.DOT=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.DOT=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.DOT=U3RXBUF[2];
				}
			}
		}break;
		case 0x07:{//读取报警点
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					tmp.BYTE[2]=U3RXBUF[4];
					tmp.BYTE[3]=U3RXBUF[5];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.A1=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.A1=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.A1=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.A1=tmp.FLOAT;
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[6];
					tmp.BYTE[1]=U3RXBUF[7];
					tmp.BYTE[2]=U3RXBUF[8];
					tmp.BYTE[3]=U3RXBUF[9];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.A2=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.A2=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.A2=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.A2=tmp.FLOAT;
					
					
				}
			}
		}break;
		case 0x09:{//读取单位代码
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.UNITCODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.UNITCODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.UNITCODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.UNITCODE=U3RXBUF[2];
				}
			}
		}break;
		case 0x0A:{//读取最大量程
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[2];
					tmp.BYTE[1]=U3RXBUF[3];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.MAXFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.MAXFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.MAXFULL=tmp.SHORT[0];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.MAXFULL=tmp.SHORT[0];
				}
			}
		}break;
		case 0x0B:{//读取气体名称代码
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.NAMECODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.NAMECODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.NAMECODE=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.NAMECODE=U3RXBUF[2];
				}
			}
		}break;
		case 0x0C:{//读取模块ID
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					tmp.UINT=0;
					tmp.BYTE[0]=U3RXBUF[1];
					tmp.BYTE[1]=U3RXBUF[2];
					tmp.BYTE[2]=U3RXBUF[3];
					tmp.BYTE[3]=U3RXBUF[4];
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.ID=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.ID=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.ID=tmp.FLOAT;
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.ID=tmp.FLOAT;
				}
			}
		}break;
		case 0x0D:{//读取模块版本号
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
						SCONFIG.ITEM.VER=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
						SCONFIG_2.ITEM.VER=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
						SCONFIG_3.ITEM.VER=U3RXBUF[2];
					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
						SCONFIG_4.ITEM.VER=U3RXBUF[2];
				}
			}
		}break;
		case 0x0E:{//读取用户区数据1
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					for(i=0;i<36;i++)
					{
						CONFIG.BYTE[i]=U3RXBUF[i+2];
//					if(U3RXBUF[0]==CONFIG.ITEM.add[0])//是第一个传感器
//						CONFIG.BYTE[i]=U3RXBUF[i+2];
//					else if(U3RXBUF[0]==CONFIG.ITEM.add[1])//是第二个传感器
//						CONFIG_2.BYTE[i]=U3RXBUF[i+2];
//					else if(U3RXBUF[0]==CONFIG.ITEM.add[2])//是第三个传感器
//						CONFIG_3.BYTE[i]=U3RXBUF[i+2];
//					else if(U3RXBUF[0]==CONFIG.ITEM.add[3])//是第四个传感器
//						CONFIG_4.BYTE[i]=U3RXBUF[i+2];
					}
				}
			}
		}break;
		case 0x20:{//设置用户量程
			tmp.UINT=0;
			if(ch==0)
				tmp.SHORT[0] = SCONFIG.ITEM.USERFULL;
			else if(ch==1)
				tmp.SHORT[0] = SCONFIG_2.ITEM.USERFULL;
			else if(ch==2)
				tmp.SHORT[0] = SCONFIG_3.ITEM.USERFULL;
			else if(ch==3)
				tmp.SHORT[0] = SCONFIG_4.ITEM.USERFULL;
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			U3TXBUF[2]=tmp.BYTE[0];
			U3TXBUF[3]=tmp.BYTE[1];
			tmp.UINT=0;
			tmp.SHORT[0]=U3TXBUF[0]+cmd+U3TXBUF[2]+U3TXBUF[3];
			U3TXBUF[4]=tmp.BYTE[0];
			U3TXBUF[5]=tmp.BYTE[1];
			U3TXLEN=6;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x21:{//设置小数点
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			if(ch==0)
				U3TXBUF[2]=SCONFIG.ITEM.DOT;
			else if(ch==1)
				U3TXBUF[2]=SCONFIG_2.ITEM.DOT;
			else if(ch==2)
				U3TXBUF[2]=SCONFIG_3.ITEM.DOT;
			else if(ch==3)
				U3TXBUF[2]=SCONFIG_4.ITEM.DOT;
			U3TXBUF[3]=0;
			U3TXBUF[4]=SCONFIG.ITEM.DOT+cmd;
			U3TXBUF[5]=0;
			U3TXLEN=6;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x23:{//设置报警点
			tmp.UINT=0;
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			tmp.SHORT[0]+=U3TXBUF[0];
			tmp.SHORT[0]+=U3TXBUF[1];
			if(ch==0)
				for(i=1;i<9;i++){U3TXBUF[i+1]=SCONFIG.BYTE[11+i];tmp.SHORT[0]+=U3TXBUF[i+1];}
			else if(ch==1)
				for(i=1;i<9;i++){U3TXBUF[i+1]=SCONFIG_2.BYTE[11+i];tmp.SHORT[0]+=U3TXBUF[i+1];}
			else if(ch==2)
				for(i=1;i<9;i++){U3TXBUF[i+1]=SCONFIG_3.BYTE[11+i];tmp.SHORT[0]+=U3TXBUF[i+1];}
			else if(ch==3)
				for(i=1;i<9;i++){U3TXBUF[i+1]=SCONFIG_4.BYTE[11+i];tmp.SHORT[0]+=U3TXBUF[i+1];}
			U3TXBUF[10]=tmp.BYTE[0];
			U3TXBUF[11]=tmp.BYTE[1];
			U3TXLEN=12;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x26:{//普通标定零点
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			JY=U3TXBUF[0]+U3TXBUF[1];
			U3TXBUF[2]=JY;
			U3TXBUF[3]=JY>>8;
			U3TXLEN=4;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x27:{//标定增益
			tmp.UINT=0;
			tmp.FLOAT=GASADJ;
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			U3TXBUF[2]=tmp.BYTE[0];
			U3TXBUF[3]=tmp.BYTE[1];
			U3TXBUF[4]=tmp.BYTE[2];
			U3TXBUF[5]=tmp.BYTE[3];
			U3TXBUF[6]=0;
			U3TXBUF[7]=0;
			U3TXBUF[8]=0;
			tmp.UINT=0;
			tmp.SHORT[0]=U3TXBUF[0]+U3TXBUF[2]+U3TXBUF[3]+U3TXBUF[4]+U3TXBUF[5]+cmd;
			U3TXBUF[9]=tmp.BYTE[0];
			U3TXBUF[10]=tmp.BYTE[1];
			U3TXLEN=11;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x2A:{//设置用户配置区
			tmp.UINT=0;
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			tmp.SHORT[0]+=U3TXBUF[0];
			tmp.SHORT[0]+=U3TXBUF[1];
			for(i=1;i<37;i++){U3TXBUF[i+1]=CONFIG.BYTE[i-1];tmp.SHORT[0]+=U3TXBUF[i+1];}
			U3TXBUF[38]=tmp.BYTE[0];
			U3TXBUF[39]=tmp.BYTE[1];
			U3TXLEN=40;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0x28:{//传感器信息保存
			tmp.UINT=0;
			U3TXBUF[0]=CONFIG.ITEM.add[ch];
			U3TXBUF[1]=cmd;
			U3TXBUF[2]=0xAA;
			U3TXBUF[3]=0x55;
			U3TXBUF[4]=0xA5;
			U3TXBUF[5]=0x5A;
			tmp.SHORT[0]=U3TXBUF[0]+U3TXBUF[1]+U3TXBUF[2]+U3TXBUF[3]+U3TXBUF[4]+U3TXBUF[5];
			U3TXBUF[6]=tmp.BYTE[0];
			U3TXBUF[7]=tmp.BYTE[1];
			U3TXLEN=8;
//			HAL_UART_Receive_DMA(&huart3,U3RXBUF,128);//启动接收
//			__HAL_UART_ENABLE_IT(&huart3, UART_IT_IDLE);
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				tmp.SHORT[0]=0;
				for(i=0;i<U3RXLEN-2;i++)tmp.SHORT[0]+=U3RXBUF[i];//计算校验和
				if(tmp.BYTE[1]==U3RXBUF[U3RXLEN-1] && tmp.BYTE[0]==U3RXBUF[U3RXLEN-2])//校验成功
				{
					if(U3RXBUF[2]!=0)
					{
						ERRSTA=(ERRSTA&0xF0)+U3RXBUF[2];//ERRSTA低4位值为U3RXBUF[1] 传感器设置错误
					}
				}
			}
		}break;
		case 0xFF:{//退出BootLoader程序
			if(From==1)
				U3TXBUF[0]=CONFIG.ITEM.add[ch];
			else U3TXBUF[0]=ch;
			U3TXBUF[1]=0xFF;
			U3TXBUF[2]=0xFF;
			U3TXLEN=3;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			osDelay(200);
			if(From==1)
				U3TXBUF[0]=CONFIG.ITEM.add[ch];
			else U3TXBUF[0]=ch;
			U3TXBUF[1]=0x24;
			U3TXBUF[2]=0x03;
			U3TXBUF[3]=0x36;
			U3TXBUF[4]=0x00;
			U3TXBUF[5]=0x00;
			U3TXLEN=6;
			HAL_UART_Receive_IT(&huart3,U3BUF,1);
			U3RXPTR=0;
			HAL_UART_Transmit_DMA(&huart3,U3TXBUF,U3TXLEN);
			if(xSemaphoreTake(U3SeampHandle,portdelay)==pdTRUE)
			{
				if(U3RXBUF[0]=='@')
				{
					
				}
			}
		}
		default:{
		}break;
	}
	osDelay(10);
}



//=============================RS485通讯函数====================================//

void U1_MASTER_CON(void)
{
	U1TXBUF[0]=U1RXBUF[0];
	U1TXBUF[2]=CONFIG.ITEM.ADDRESS;
	if(SYSBIT&0x02)   //TC200协议
	{
		U1TXBUF[1]=0;
		if((U1RXBUF[3]&0x80)==0) //读命令
		{
			switch(U1RXBUF[3]){
				case 0x00:{       //读取浓度值
					if(!SCONFIG.ITEM.DOT) U1TXBUF[3]=STATE;
					else U1TXBUF[3]=STATE|0x80;
					U1TXBUF[4]=((u16)(SCONFIG.ITEM.GASVAL))>>8;
					U1TXBUF[5]=((u16)(SCONFIG.ITEM.GASVAL));
					U1TXBUF[6]=SCONFIG.ITEM.UNITCODE;
					U1TXBUF[7]=SCONFIG.ITEM.NAMECODE;
				}break;
				case 0x01:{       //读取低高报值
					if(!SCONFIG.ITEM.DOT) U1TXBUF[3]=STATE;
					else  U1TXBUF[3]=STATE|0x80;
					U1TXBUF[5]=((u16)(SCONFIG.ITEM.A1));
					U1TXBUF[4]=((u16)(SCONFIG.ITEM.A1))>>8;
					U1TXBUF[7]=((u16)(SCONFIG.ITEM.A2));
					U1TXBUF[6]=((u16)(SCONFIG.ITEM.A1))>>8;
				}break;
			}
		}
		else                    //写命令
		{
			switch(U1RXBUF[3]){
				case 0x81:{       //设置气体单位
					SCONFIG.ITEM.UNITCODE=U1RXBUF[5];
					SETFLAG|=(1<<0);
				}break;
				case 0x80:{       //设置气体类型
					SCONFIG.ITEM.NAMECODE=U1RXBUF[6];
					SETFLAG|=(1<<1);
				}break;
				case 0x82:{       //设置气体小数点
					SCONFIG.ITEM.DOT=U1RXBUF[7];
					SETFLAG|=(1<<2);
				}break;
				case 0x83:{       //标定零点
					SETFLAG|=(1<<3);
				}break;
				case 0x84:{       //标定标定点
					GASADJ=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<4);
				}break;
				case 0x89:{       //设置量程
					SCONFIG.ITEM.USERFULL=U1RXBUF[4]*256+U1RXBUF[5];
					SETFLAG|=(1<<5);
				}break;
				case 0x8A:{       //设置低报值
					SCONFIG.ITEM.A1=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<6);
				}break;
				case 0x8B:{       //设置高报值
					SCONFIG.ITEM.A2=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<6);
				}break;
			}
			if(!SCONFIG.ITEM.DOT)U1TXBUF[3]=STATE;
			else U1TXBUF[3]=STATE|0x80;
			U1TXBUF[4]=((u16)(SCONFIG.ITEM.GASVAL))>>8;
			U1TXBUF[5]=((u16)(SCONFIG.ITEM.GASVAL));
			U1TXBUF[6]=SCONFIG.ITEM.UNITCODE;
			U1TXBUF[7]=SCONFIG.ITEM.NAMECODE;
		}
		U1TXLEN=9;
		U1TXBUF[8]=CheckSum(U1TXBUF,9);
	}
	else              //HKB8000协议
	{
		U1TXBUF[1]=0;
		if((U1RXBUF[3]&0x20)==0) //读命令
		{
			switch(U1RXBUF[3]){
				case 0x10:{          //读取浓度值
					U1TXBUF[3]=STATE|0x10;
					U1TXBUF[4]=((u16)(SCONFIG.ITEM.GASVAL))>>8;
					U1TXBUF[5]=((u16)(SCONFIG.ITEM.GASVAL));
					U1TXBUF[6]=SCONFIG.ITEM.UNITCODE;
					U1TXBUF[7]=SCONFIG.ITEM.NAMECODE;
					U1TXBUF[8]=SCONFIG.ITEM.DOT;
				}break;
				case 0x11:{          //读取低高报值
					U1TXBUF[3]=STATE|0x10;
					U1TXBUF[4]=((u16)(SCONFIG.ITEM.A1))>>8;
					U1TXBUF[5]=(u16)(SCONFIG.ITEM.A1);
					U1TXBUF[6]=((u16)(SCONFIG.ITEM.A2))>>8;
					U1TXBUF[7]=(u16)(SCONFIG.ITEM.A2);
					U1TXBUF[8]=SCONFIG.ITEM.USERFULL>>8;
					U1TXBUF[9]=SCONFIG.ITEM.USERFULL;
				}break;
			}
		}
		else                  //写命令
		{
			switch(U1RXBUF[3]){
				case 0x20:{       //设置气体单位
					SCONFIG.ITEM.UNITCODE=U1RXBUF[5];
					SETFLAG|=(1<<0);
				}break;
				case 0x21:{       //设置气体类型
					SCONFIG.ITEM.NAMECODE=U1RXBUF[6];
					SETFLAG|=(1<<1);
				}break;
				case 0x22:{       //设置气体小数点
					SCONFIG.ITEM.DOT=U1RXBUF[7];
					SETFLAG|=(1<<2);
				}break;
				case 0x23:{       //标定零点
					SETFLAG|=(1<<3);
				}break;
				case 0x24:{       //标定标定点
					GASADJ=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<4);
				}break;
				case 0x29:{       //设置量程
					SCONFIG.ITEM.USERFULL=U1RXBUF[4]*256+U1RXBUF[5];
					SETFLAG|=(1<<5);
				}break;
				case 0x2A:{       //设置低报值
					SCONFIG.ITEM.A1=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<6);
				}break;
				case 0x2B:{       //设置高报值
					SCONFIG.ITEM.A2=(float)(U1RXBUF[4]*256+U1RXBUF[5]);
					SETFLAG|=(1<<6);
				}break;
			}
			U1TXBUF[3]=STATE|0x10;
			U1TXBUF[4]=((u16)(SCONFIG.ITEM.GASVAL))>>8;
			U1TXBUF[5]=((u16)(SCONFIG.ITEM.GASVAL));
			U1TXBUF[6]=SCONFIG.ITEM.UNITCODE;
			U1TXBUF[7]=SCONFIG.ITEM.NAMECODE;
			U1TXBUF[8]=SCONFIG.ITEM.DOT;
		}
		U1TXLEN=12;
		U1TXBUF[11]=CheckSum(U1TXBUF,12);
	}
	U1TXMODE;//开启RS485发送模式
//	__HAL_UART_ENABLE_IT(&huart1, UART_IT_IDLE);
	HAL_UART_Transmit_DMA(&huart1,U1TXBUF,U1TXLEN);
}



//=============================HART 通讯函数====================================//

4.中断函数
/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    stm32l1xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32l1xx_it.h"
#include "cmsis_os.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "define.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */

/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
 
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
extern TIM_HandleTypeDef htim2;
extern TIM_HandleTypeDef htim6;
extern DMA_HandleTypeDef hdma_usart1_tx;
extern DMA_HandleTypeDef hdma_usart1_rx;
extern DMA_HandleTypeDef hdma_usart2_tx;
extern DMA_HandleTypeDef hdma_usart2_rx;
extern DMA_HandleTypeDef hdma_usart3_tx;
extern DMA_HandleTypeDef hdma_usart3_rx;
extern UART_HandleTypeDef huart1;
extern UART_HandleTypeDef huart2;
extern UART_HandleTypeDef huart3;
/* USER CODE BEGIN EV */

/* USER CODE END EV */

/******************************************************************************/
/*           Cortex-M3 Processor Interruption and Exception Handlers          */ 
/******************************************************************************/
/**
  * @brief This function handles Non maskable interrupt.
  */
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */

  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
  * @brief This function handles Hard fault interrupt.
  */
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Memory management fault.
  */
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
}

/**
  * @brief This function handles Pre-fetch fault, memory access fault.
  */
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Undefined instruction or illegal state.
  */
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Debug monitor.
  */
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
  * @brief This function handles System tick timer.
  */
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */
	u8 ch_num=0,i=0;
	portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
	static u8 one_sec_con=0;
	if(SYSTICKCNT++>=1000)//1000ms
	{
		SYSTICKCNT=0;
		one_sec_con++;
	}
	if(U1_RX_START_FLAG==1)
	{
		if(usart1_tim++>5)
		{
			usart1_tim=0;
			U1_RX_START_FLAG=0;
			U1RXLEN=U1RXPTR;
			U1_rx_ok=1;
//			xSemaphoreGiveFromISR( U1SeampHandle, &xHigherPriorityTaskWoken );//发送信号量
//			portYIELD_FROM_ISR( xHigherPriorityTaskWoken );	//任务切换
		}
	}
	if(one_sec_con>=CONFIG.ITEM.Time_FY)//翻页时间判断
	{
		one_sec_con=0;
		for(i=0;i<4;i++)
		{
			if(CONFIG.ITEM.add[i]!=0)
				ch_num++;
		}
		if(CH_FLAG++>=ch_num-1)  //3
			CH_FLAG=0;
	}
  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  osSystickHandler();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32L1xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32l1xx.s).                    */
/******************************************************************************/

/**
  * @brief This function handles DMA1 channel2 global interrupt.
  */
void DMA1_Channel2_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel2_IRQn 0 */

  /* USER CODE END DMA1_Channel2_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart3_tx);
  /* USER CODE BEGIN DMA1_Channel2_IRQn 1 */

  /* USER CODE END DMA1_Channel2_IRQn 1 */
}

/**
  * @brief This function handles DMA1 channel3 global interrupt.
  */
void DMA1_Channel3_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel3_IRQn 0 */

  /* USER CODE END DMA1_Channel3_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart3_rx);
  /* USER CODE BEGIN DMA1_Channel3_IRQn 1 */

  /* USER CODE END DMA1_Channel3_IRQn 1 */
}

/**
  * @brief This function handles DMA1 channel4 global interrupt.
  */
void DMA1_Channel4_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel4_IRQn 0 */

  /* USER CODE END DMA1_Channel4_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart1_tx);
  /* USER CODE BEGIN DMA1_Channel4_IRQn 1 */

  /* USER CODE END DMA1_Channel4_IRQn 1 */
}

/**
  * @brief This function handles DMA1 channel5 global interrupt.
  */
void DMA1_Channel5_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel5_IRQn 0 */

  /* USER CODE END DMA1_Channel5_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart1_rx);
  /* USER CODE BEGIN DMA1_Channel5_IRQn 1 */

  /* USER CODE END DMA1_Channel5_IRQn 1 */
}

/**
  * @brief This function handles DMA1 channel6 global interrupt.
  */
void DMA1_Channel6_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel6_IRQn 0 */

  /* USER CODE END DMA1_Channel6_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart2_rx);
  /* USER CODE BEGIN DMA1_Channel6_IRQn 1 */

  /* USER CODE END DMA1_Channel6_IRQn 1 */
}

/**
  * @brief This function handles DMA1 channel7 global interrupt.
  */
void DMA1_Channel7_IRQHandler(void)
{
  /* USER CODE BEGIN DMA1_Channel7_IRQn 0 */

  /* USER CODE END DMA1_Channel7_IRQn 0 */
  HAL_DMA_IRQHandler(&hdma_usart2_tx);
  /* USER CODE BEGIN DMA1_Channel7_IRQn 1 */

  /* USER CODE END DMA1_Channel7_IRQn 1 */
}

/**
  * @brief This function handles TIM2 global interrupt.
  */
void TIM2_IRQHandler(void)
{
  /* USER CODE BEGIN TIM2_IRQn 0 */
	/*
	static uint16_t revdata=0;
	static uint16_t ICValue;
	*/
  /* USER CODE END TIM2_IRQn 0 */
  HAL_TIM_IRQHandler(&htim2);
  /* USER CODE BEGIN TIM2_IRQn 1 */
	/*
	if(__HAL_UART_GET_FLAG(&htim2, TIM_FLAG_UPDATE)){
//		__HAL_TIM_DISABLE_IT(&htim2, TIM_IT_UPDATE);
		HAL_TIM_Base_Stop_IT(&htim2);
		TIM2BITCNT=0;																//复位位接收计数器
		if(TIM2BYTECNT>0)														//第二次收到数据
		{
			if(revdata==TIM2REVBIT)										//前后两次值相同
			{
				if(revdata==0x2AF)KEYVAL=KEY_ST;			  //输出按键值
				else if(revdata==0x2B7)KEYVAL=KEY_OK;
				else if(revdata==0x2BB)KEYVAL=KEY_CL;
				else if(revdata==0x377)KEYVAL=KEY_UP;
				else if(revdata==0x36F)KEYVAL=KEY_DN;
				TIM2BYTECNT=0;													//复位数据接收计数器,等待下一个键按下
			}
			else																			//前后两次值不相同
			{
				revdata=TIM2REVBIT;											//再次保存收到的数据,等待下一数据(丢弃先前收到的数据)
			}
		}
		else																				//第一次收到数据
		{
			revdata=TIM2REVBIT;												//保存收到的数据
			TIM2BYTECNT++;														//等待下一个数据
		}
	}
	if(__HAL_UART_GET_FLAG(&htim2, TIM_FLAG_CC2)){
		 __HAL_TIM_SET_COUNTER(&htim2,0);
		ICValue=HAL_TIM_ReadCapturedValue(&htim2, TIM_CHANNEL_2);
		if(TIM2BITCNT++!=0)															//不是收到第一个下降沿
		{
			TIM2REVBIT<<=1;
			if(ICValue>30600)TIM2REVBIT++;								  //获得数据位
		}
		else																						//收到第一个下降沿,开更新中断
		{
			TIM2REVBIT=0;																	//复位位数据
			HAL_TIM_Base_Start_IT(&htim2);
		}
	}
	*/
  /* USER CODE END TIM2_IRQn 1 */
}


/**
  * @brief This function handles TIM6 global interrupt.
  */
void TIM6_IRQHandler(void)
{
  /* USER CODE BEGIN TIM6_IRQn 0 */

  /* USER CODE END TIM6_IRQn 0 */
  HAL_TIM_IRQHandler(&htim6);
  /* USER CODE BEGIN TIM6_IRQn 1 */
	
  /* USER CODE END TIM6_IRQn 1 */
}
/**
  * @brief This function handles TIM7 global interrupt.
  */
void TIM7_IRQHandler(void)
{
  /* USER CODE BEGIN TIM7_IRQn 0 */

  /* USER CODE END TIM7_IRQn 0 */
  HAL_TIM_IRQHandler(&htim7);
  /* USER CODE BEGIN TIM7_IRQn 1 */

  /* USER CODE END TIM7_IRQn 1 */
}
/* USER CODE BEGIN 1 */
/**
  * @brief This function handles USART1 global interrupt.
  */
void USART1_IRQHandler(void)
{
  /* USER CODE BEGIN USART1_IRQn 0 */
	portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
	extern osSemaphoreId U1SeampHandle;
//	if(__HAL_UART_GET_FLAG(&huart1, UART_FLAG_IDLE)){
//		unsigned int tmp;
//		tmp=USART1->SR;																//复位IDLE中断标志
//		tmp=USART1->DR;
//		(void)tmp;
//		__HAL_UART_DISABLE_IT(&huart1, UART_IT_IDLE);	//禁止IDLE中断
//		HAL_UART_DMAStop(&huart1);										//停止DMA传输
//		U1RXLEN=128-huart1.hdmarx->Instance->CNDTR;			//计算接收数据长度
//		//添加USART1接收判断程序 判断数据接收是否正常并置RS485接收处理标志位
//		if((U1RXBUF[0]==0xFF ||U1RXBUF[0]==0xE5||U1RXBUF[0]==0xAA)&&U1RXBUF[1]==CONFIG.ITEM.ADDRESS&& U1RXBUF[U1RXLEN-1]==CheckSum(U1RXBUF,U1RXLEN))
//		{
//			SYSBIT|=0x01;
//			if(U1RXBUF[0]==0xFF)SYSBIT|=(1<<1);
//			else if(U1RXBUF[0]==0xE5||U1RXBUF[0]==0xAA)SYSBIT&=~(1<<1);
//		}
//		else
//		{
//			SYSBIT|=(1<<6);
//		}
//		xSemaphoreGiveFromISR( U1SeampHandle, &xHigherPriorityTaskWoken );//发送信号量
//		//发送信号量
//	}
//	else{
  /* USER CODE END USART1_IRQn 0 */
  HAL_UART_IRQHandler(&huart1);
  /* USER CODE BEGIN USART1_IRQn 1 */
//	}
//	portYIELD_FROM_ISR( xHigherPriorityTaskWoken );	//任务切换
  /* USER CODE END USART1_IRQn 1 */
}

/**
  * @brief This function handles USART2 global interrupt.
  */
void USART2_IRQHandler(void)
{
  /* USER CODE BEGIN USART2_IRQn 0 */
	portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
	extern osSemaphoreId U2SeampHandle;
	if(__HAL_UART_GET_FLAG(&huart2, UART_FLAG_IDLE)){
		unsigned int tmp;
		tmp=USART2->SR;																//复位IDLE中断标志
		tmp=USART2->DR;
		(void)tmp;
		__HAL_UART_DISABLE_IT(&huart2, UART_IT_IDLE);	//禁止IDLE中断
		HAL_UART_DMAStop(&huart2);										//停止DMA传输
		U2RXLEN=128-huart2.hdmarx->Instance->CNDTR;			//计算接收数据长度
		xSemaphoreGiveFromISR( U2SeampHandle, &xHigherPriorityTaskWoken );//发送信号量
		//发送信号量
	}
	else{
  /* USER CODE END USART2_IRQn 0 */
  HAL_UART_IRQHandler(&huart2);
  /* USER CODE BEGIN USART2_IRQn 1 */
	}
	portYIELD_FROM_ISR( xHigherPriorityTaskWoken );	//任务切换
  /* USER CODE END USART2_IRQn 1 */
}

/**
  * @brief This function handles USART3 global interrupt.
  */
void USART3_IRQHandler(void)
{
  /* USER CODE BEGIN USART3_IRQn 0 */
//	portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
//	extern osSemaphoreId U3SeampHandle;
//	if(__HAL_UART_GET_FLAG(&huart3, UART_FLAG_IDLE)){
//		unsigned int tmp;
//		tmp=USART3->SR;																//复位IDLE中断标志
//		tmp=USART3->DR;
//		(void)tmp;
//		__HAL_UART_DISABLE_IT(&huart3, UART_IT_IDLE);	//禁止IDLE中断
//		HAL_UART_DMAStop(&huart3);										//停止DMA传输
//		U3RXLEN=128-huart3.hdmarx->Instance->CNDTR;			//计算接收数据长度
//		xSemaphoreGiveFromISR( U3SeampHandle, &xHigherPriorityTaskWoken );//发送信号量
//		//发送信号量
//	}
//	else{
  /* USER CODE END USART3_IRQn 0 */
  HAL_UART_IRQHandler(&huart3);
  /* USER CODE BEGIN USART3_IRQn 1 */
//	}
//	portYIELD_FROM_ISR( xHigherPriorityTaskWoken );	//任务切换
  /* USER CODE END USART3_IRQn 1 */
}







/* USER CODE END 1 */
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/`;

const t3333 = `
5.4G模块处理函数
	#include "define.h"
#include "string.h"
#include "stdio.h"
#include "stdarg.h"	
//#endif
//串口发送函数
void UART_Transmit(UART_HandleTypeDef *huart, uint8_t *pData, uint16_t Size, uint32_t Timeout)
{
	HAL_UART_Transmit(huart,pData,Size, Timeout);
}
///*******************************************************
//*
//* Function name      : UART string Send Function
//* Description        : UART string Send
//* Parameter          : 
//*                      @pUSARTx     Type of USART(USART1 or USART2)
//*                      @str         addr of data that will send by USART  
//* Return             : NONE
//**********************************************************/
//void Usart_SendString(uint8_t *str)
//{
//	unsigned int k=0;
//	do 
//	{
//			HAL_UART_Transmit(&huart1,str + k,1,100);
////			Usart_SendByte( pUSARTx, *(str + k) );
//			k++;
//	} while(*(str + k)!='\0');
//}
//串口3,printf 函数
//确保一次发送数据不超过USART3_MAX_SEND_LEN字节
void u_printf(char* fmt,...)  
{  
	u16 i; 
	va_list ap; 
	va_start(ap,fmt);
	vsprintf((char*)U1TXBUF,fmt,ap);
	va_end(ap);
	i=strlen((const char*)U1TXBUF);		//此次发送数据的长度
	UART_Transmit(&huart1,U1TXBUF,i,100);
}
//str:期待的应答结果
//返回值:0,没有得到期待的应答结果
//    其他,期待应答结果的位置(str的位置)
u8* Dtu_check_cmd(u8 *str)
{
	char *strx=0;
	if(U1_rx_ok == 1)		//接收到一次数据了
	{ 
		U1_rx_ok =0; 
		U1RXBUF[U1RXPTR]=0;//添加结束符
		strx=strstr(( char*)U1RXBUF,(const char*)str);
		U1RXPTR=0;//清空计数器
		memset(U1RXBUF,0,sizeof(U1RXBUF));
	} 
	return (u8*)strx;
}
//向DTU发送命令
//cmd:发送的命令字符串(不需要添加回车了),当cmd<0XFF的时候,发送数字(比如发送0X1A),大于的时候发送字符串.
//ack:期待的应答结果,如果为空,则表示不需要等待应答
//waittime:等待时间(单位:10ms)
//返回值:0,发送成功(得到了期待的应答结果)
//       1,发送失败
u8 Dtu_send_cmd(u8 *cmd,u8 *ack,u16 waittime)
{
	u8 res=0; 
	U1_rx_ok=0;
	U1RXPTR=0;
	if((u32)cmd<=0XFF)
	{
		UART_Transmit(&huart1,U1TXBUF,1,100);
	}else u_printf("%s\r\n",cmd);//发送命令
	if(ack&&waittime)		//需要等待应答
	{
		while(--waittime)	//等待倒计时
		{
			HAL_Delay(10);
			if(U1_rx_ok == 1)//接收到期待的应答结果
			{
				if(Dtu_check_cmd(ack)) break;//得到有效数据 
				U1_rx_ok =0;
			} 
		}
		if(waittime==0)res=1; 
	}
	return res;
} 
//获取信号强度
u8 Get_CSQ_strong(u8 *cmd,u16 waittime) 
{
	
	u8 res=0; 
	U1_rx_ok=0;
	u_printf("%s\r\n",cmd);//发送命令
	if(waittime)				//需要等待应答
	{
		while(--waittime)	//等待倒计时
		{
			HAL_Delay(10);
			if(U1_rx_ok == 1)//接收到期待的应答结果
			{
				U1_rx_ok =0;
				U1RXPTR=0;//清空计数器
				RSSI_VAL=atoi((const char*)&U1RXBUF[15]);//十进制字符串转十六进制  RSSI =CSQ *2-113
				memset(U1RXBUF,0,sizeof(U1RXBUF));
				break;
			} 
		}
		if(waittime==0)res=1; 
	}
	return res;
}
//信号质量显示函数
extern u16 Get_Adc_Average(u32 ch,u8 times);
void XH_SING()
{
		float bat_val=0;
		if(RSSI_VAL<10)
			LCD_DISICON(SIGINL_0,ON);//显示信号质量
		else if(RSSI_VAL>=10 && RSSI_VAL<20)
			LCD_DISICON(SIGINL_1,ON);//显示信号质量
		else if(RSSI_VAL>=20 )
			LCD_DISICON_storng(SIGINL_2,ON);//显示信号质量
		else //错误
		{
			LCD_DISICON(SIGINL_0,OFF);//显示信号质量
			LCD_DISICON(SIGINL_1,OFF);//显示信号质量
			LCD_DISICON(SIGINL_2,OFF);//显示信号质量
		}
		bat_val=Get_Adc_Average(0,10);
		bat_val=bat_val/4096*3.3;//0.996-12.5   0.67-9
		if(bat_val>0.75&& bat_val<=0.83) 
		{
			LCDATA[22]=9;
			SYS_sta=1;
		}
		else if(bat_val>0.83 && bat_val<=0.91) 
		{
			LCDATA[22]=13;
			SYS_sta=1;//正常
		}
		else if(bat_val>0.91 ) 
		{
			LCDATA[22]=15;
			SYS_sta=2;//电量低
		}
		else //没电了
		{
			LCDATA[22]=1;
			SYS_sta=2;//电量低
		}
}
/**************************************
//函数功能：获取设备IMEI号
//输入参数：
//输出参数：
//备    注：延时以10MS为单位   0：成功   1：失败  
**************************************/
u8 Dtu_Query_IMEI(u8 *cmd,u16 waittime)
{
	u8 res=0; 
	U1_rx_ok=0;
	u_printf("%s\r\n",cmd);//发送命令
	if(waittime)				//需要等待应答
	{
		while(--waittime)	//等待倒计时
		{
			HAL_Delay(10);
			if(U1_rx_ok == 1)//接收到期待的应答结果
			{
				U1_rx_ok =0;
				U1RXPTR=0;//清空计数器
				memcpy((char*)IMEI,&U1RXBUF[15],sizeof(IMEI));//提取IMEI号
				memset(U1RXBUF,0,sizeof(U1RXBUF));
				break;
			} 
		}
		if(waittime==0)res=1; 
	}
	return res;
} 
/*******************************************************
*
* Function name      : Change Modul mode is CMD Function
* Description        : Change Modul mode is CMD
* Parameter          : NONE
* Return             : NONE
**********************************************************/
void TCP_config() 
{
//		Dtu_send_cmd("+++","+++",200);
//		Dtu_send_cmd("a","a",200);
		U1RXPTR=0;
//		if(Dtu_send_cmd("","ok",30000)==0) //NET模式下进入配置成功   
//		{
			Dtu_send_cmd("usr.cn#AT+CLEAR\r\n","OK",1000);  //恢复出厂设置
			Dtu_send_cmd("usr.cn#AT+WKMOD=NET\r\n","OK",500); //工作模式修改
			Dtu_send_cmd("usr.cn#AT+HEARTEN=OFF\r\n","OK",500); 
			Dtu_send_cmd("usr.cn#AT+REGEN=OFF\r\n","OK",500); 
			//客户可根据自己服务器的ip和端口修改此指令的参数
			Dtu_send_cmd("usr.cn#AT+SOCKA=UDP,36.148.1.58,1500\r\n","OK",500); //服务器地址配置
			Dtu_Query_IMEI( "usr.cn#AT+IMEI?\r\n",500);//获取IMEI
			Dtu_send_cmd( "usr.cn#AT+ICCID?\r\n","+ICCID",500);//获取iccid
			Dtu_send_cmd("usr.cn#AT+S\r\n","OK",1000);//重启并保存
			Dtu_send_cmd("","WH-GM5",1000);//等待启动
//		}
}

/*******************************************************
*
* Function name      : TCP send Function
* Description        : TCP send
* Parameter          : NONE
* Return             : NONE
**********************************************************/
void TCP_send()
{
	Get_CSQ_strong("usr.cn#AT+CSQ?",500);//查询信号质量
	if(Dtu_send_cmd("usr.cn#AT+SOCKALK\r\n","Connect",500)==0) //查询连接状态
	{
//		Dtu_send_cmd("usr.cn#AT+CIPSEND\r\n",">",200); //
		//内容
		sprintf((char *)U1TXBUF,"%s",(char*)IMEI);//发送数据
		sprintf((char *)&U1TXBUF[15],"/%d/%d,%0.1f,%d,%d/%d,%0.1f,%d,%d/%d,%0.1f,%d,%d/%d,%0.1f,%d,%d/", SYS_sta, CONFIG.ITEM.add[0],SCONFIG.ITEM.GASVAL,SCONFIG.ITEM.UNITCODE,SCONFIG.ITEM.STATE,
																																																			CONFIG.ITEM.add[1],SCONFIG_2.ITEM.GASVAL,SCONFIG_2.ITEM.UNITCODE,SCONFIG_2.ITEM.STATE,
																																																			CONFIG.ITEM.add[2],SCONFIG_3.ITEM.GASVAL,SCONFIG_3.ITEM.UNITCODE,SCONFIG_3.ITEM.STATE,
																																																			CONFIG.ITEM.add[3],SCONFIG_4.ITEM.GASVAL,SCONFIG_4.ITEM.UNITCODE,SCONFIG_4.ITEM.STATE);//发送数据
		UART_Transmit(&huart1,U1TXBUF,strlen(U1TXBUF),100);
	}
}

`;
const arr = [t1111, t2222, t3333];
export { arr };
